/* smtp-client-service.c generated by valac 0.56.15, the Vala compiler
 * generated from smtp-client-service.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2018, 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gmime/gmime.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GEARY_SMTP_CLIENT_SERVICE_0_PROPERTY,
	GEARY_SMTP_CLIENT_SERVICE_OUTBOX_PROPERTY,
	GEARY_SMTP_CLIENT_SERVICE_SENDING_MONITOR_PROPERTY,
	GEARY_SMTP_CLIENT_SERVICE_LOGGING_DOMAIN_PROPERTY,
	GEARY_SMTP_CLIENT_SERVICE_NUM_PROPERTIES
};
static GParamSpec* geary_smtp_client_service_properties[GEARY_SMTP_CLIENT_SERVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GearySmtpClientServiceStartData GearySmtpClientServiceStartData;
typedef struct _GearySmtpClientServiceStopData GearySmtpClientServiceStopData;
typedef struct _GearySmtpClientServiceSendEmailData GearySmtpClientServiceSendEmailData;
typedef struct _GearySmtpClientServiceSaveEmailData GearySmtpClientServiceSaveEmailData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearySmtpClientServiceStartPostieData GearySmtpClientServiceStartPostieData;
typedef struct _GearySmtpClientServiceFillOutboxQueueData GearySmtpClientServiceFillOutboxQueueData;
typedef struct _GearySmtpClientServiceProcessEmailData GearySmtpClientServiceProcessEmailData;
#define _geary_smtp_response_unref0(var) ((var == NULL) ? NULL : (var = (geary_smtp_response_unref (var), NULL)))
typedef struct _GearySmtpClientServiceSendEmailInternalData GearySmtpClientServiceSendEmailInternalData;
typedef struct _GearySmtpClientServiceSaveSentMailData GearySmtpClientServiceSaveSentMailData;
typedef struct _GearySmtpClientServiceSyncSentMailData GearySmtpClientServiceSyncSentMailData;
typedef struct _GearySmtpClientServiceWaitForMessageData GearySmtpClientServiceWaitForMessageData;
enum  {
	GEARY_SMTP_CLIENT_SERVICE_EMAIL_SENT_SIGNAL,
	GEARY_SMTP_CLIENT_SERVICE_REPORT_PROBLEM_SIGNAL,
	GEARY_SMTP_CLIENT_SERVICE_NUM_SIGNALS
};
static guint geary_smtp_client_service_signals[GEARY_SMTP_CLIENT_SERVICE_NUM_SIGNALS] = {0};

struct _GearySmtpClientServicePrivate {
	GearyOutboxFolder* _outbox;
	GearyProgressMonitor* _sending_monitor;
	GearyNonblockingQueue* outbox_queue;
	GCancellable* queue_cancellable;
};

struct _GearySmtpClientServiceStartData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientService* self;
	GCancellable* cancellable;
	GearyOutboxFolder* _tmp0_;
	GError* _inner_error0_;
};

struct _GearySmtpClientServiceStopData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientService* self;
	GCancellable* cancellable;
	GCancellable* _tmp0_;
	GearyOutboxFolder* _tmp1_;
	GError* _inner_error0_;
};

struct _GearySmtpClientServiceSendEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientService* self;
	GearyComposedEmail* composed;
	GCancellable* cancellable;
	GearyEmailIdentifier* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GError* _inner_error0_;
};

struct _GearySmtpClientServiceSaveEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientService* self;
	GearyComposedEmail* composed;
	GCancellable* cancellable;
	GearyEmailIdentifier* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyRFC822MailboxAddresses* from;
	GearyRFC822MailboxAddresses* _tmp2_;
	GearyRFC822MailboxAddresses* _tmp3_;
	GearyRFC822MailboxAddresses* _tmp4_;
	const gchar* _tmp5_;
	gboolean _tmp6_;
	GearyRFC822MailboxAddresses* _tmp7_;
	GearyRFC822MailboxAddresses* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GearyRFC822MailboxAddresses* _tmp11_;
	GearyRFC822MailboxAddress* _tmp12_;
	GearyRFC822MailboxAddress* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GearyAccountInformation* _tmp16_;
	GearyAccountInformation* _tmp17_;
	GearyRFC822MailboxAddress* _tmp18_;
	GearyRFC822MailboxAddress* _tmp19_;
	GearyRFC822MailboxAddress* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* domain;
	gchar* _tmp23_;
	GearyRFC822Message* rfc822;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GearyRFC822Message* _tmp27_;
	GearyRFC822Message* _tmp28_;
	GearyEmailIdentifier* id;
	GearyOutboxFolder* _tmp29_;
	GearyRFC822Message* _tmp30_;
	GearyEmailIdentifier* _tmp31_;
	GearyEmailIdentifier* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	GError* _inner_error0_;
};

struct _GearySmtpClientServiceStartPostieData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientService* self;
	GearyNonblockingQueue* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* cancellable;
	GCancellable* _tmp4_;
	GCancellable* _tmp5_;
	GCancellable* _tmp6_;
	GCancellable* _tmp7_;
	GearyEmailIdentifier* id;
	gboolean email_handled;
	GearyEmailIdentifier* _tmp8_;
	GearyNonblockingQueue* _tmp9_;
	GCancellable* _tmp10_;
	gpointer _tmp11_;
	GearyEmailIdentifier* _tmp12_;
	GearyEmailIdentifier* _tmp13_;
	GCancellable* _tmp14_;
	GError* err;
	GError* _tmp15_;
	gboolean _tmp16_;
	GError* _tmp17_;
	GError* _tmp18_;
	GError* _tmp19_;
	GearyErrorContext* _tmp20_;
	GearyErrorContext* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	GError* _tmp24_;
	GError* _tmp25_;
	GError* _tmp26_;
	GError* _tmp27_;
	GearyErrorContext* _tmp28_;
	GearyErrorContext* _tmp29_;
	GCancellable* _tmp30_;
	GError* _vala1_err;
	GearyEmailIdentifier* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GError* _tmp34_;
	const gchar* _tmp35_;
	GError* _vala2_err;
	GError* _tmp36_;
	GearyErrorContext* _tmp37_;
	GearyErrorContext* _tmp38_;
	GCancellable* _tmp39_;
	gboolean _tmp40_;
	GearyEmailIdentifier* _tmp41_;
	GearyNonblockingQueue* _tmp42_;
	GearyEmailIdentifier* _tmp43_;
	GError* _inner_error0_;
};

struct _GearySmtpClientServiceFillOutboxQueueData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientService* self;
	GCancellable* cancellable;
	GeeList* queued;
	GearyOutboxFolder* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _email_list;
	gint _email_size;
	GeeList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _email_index;
	gint _tmp5_;
	gint _tmp6_;
	GearyEmail* email;
	GeeList* _tmp7_;
	gpointer _tmp8_;
	GearyNonblockingQueue* _tmp9_;
	GearyEmail* _tmp10_;
	GearyEmailIdentifier* _tmp11_;
	GearyEmailIdentifier* _tmp12_;
	GError* err;
	GError* _tmp13_;
	const gchar* _tmp14_;
	GError* _inner_error0_;
};

struct _GearySmtpClientServiceProcessEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientService* self;
	GearyEmailIdentifier* id;
	GCancellable* cancellable;
	gboolean _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyAccountInformation* _tmp2_;
	GError* _tmp3_;
	GearyEmail* email;
	GearyOutboxFolder* _tmp4_;
	GearyEmail* _tmp5_;
	GearyEmail* _tmp6_;
	GearyEmailFlags* _tmp7_;
	GearyEmailFlags* _tmp8_;
	GearyNamedFlag* _tmp9_;
	GearyNamedFlag* _tmp10_;
	GearyNamedFlag* _tmp11_;
	gboolean _tmp12_;
	GearyRFC822Message* message;
	GearyEmail* _tmp13_;
	GearyRFC822Message* _tmp14_;
	GearyRFC822Message* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GearyEmail* _tmp18_;
	GearyEmailIdentifier* _tmp19_;
	GearyEmailIdentifier* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GearyRFC822Message* _tmp23_;
	GearyEmail* _tmp24_;
	GearyEmail* _tmp25_;
	GearyEmailIdentifier* _tmp26_;
	GearyEmailIdentifier* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GearyEmailFlags* flags;
	GearyEmailFlags* _tmp30_;
	GearyEmailFlags* _tmp31_;
	GearyNamedFlag* _tmp32_;
	GearyNamedFlag* _tmp33_;
	GearyNamedFlag* _tmp34_;
	GearyOutboxFolder* _tmp35_;
	GearyEmail* _tmp36_;
	GearyEmailIdentifier* _tmp37_;
	GearyEmailIdentifier* _tmp38_;
	GeeCollection* _tmp39_;
	GeeCollection* _tmp40_;
	GearyEmailFlags* _tmp41_;
	GError* _tmp42_;
	GearyAccountInformation* _tmp43_;
	GearyAccountInformation* _tmp44_;
	gboolean _tmp45_;
	gboolean _tmp46_;
	GearyEmail* _tmp47_;
	GearyEmailIdentifier* _tmp48_;
	GearyEmailIdentifier* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	GearyEmail* _tmp52_;
	GearyEmail* _tmp53_;
	GearyEmailIdentifier* _tmp54_;
	GearyEmailIdentifier* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	GearyEmail* _tmp58_;
	GearyEmail* _tmp59_;
	GearyEmailIdentifier* _tmp60_;
	GearyEmailIdentifier* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	GearyOutboxFolder* _tmp64_;
	GearyEmail* _tmp65_;
	GearyEmailIdentifier* _tmp66_;
	GearyEmailIdentifier* _tmp67_;
	GeeCollection* _tmp68_;
	GeeCollection* _tmp69_;
	GError* _inner_error0_;
};

struct _GearySmtpClientServiceSendEmailInternalData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientService* self;
	GearyRFC822Message* rfc822;
	GCancellable* cancellable;
	GearyCredentials* login;
	GearyAccountInformation* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyCredentials* _tmp2_;
	gboolean _tmp3_;
	GearyCredentials* _tmp4_;
	GearyCredentials* _tmp5_;
	GError* _tmp6_;
	GearySmtpClientSession* smtp;
	GearyEndpoint* _tmp7_;
	GearyEndpoint* _tmp8_;
	GearySmtpClientSession* _tmp9_;
	GearySmtpClientSession* _tmp10_;
	GearyProgressMonitor* _tmp11_;
	GError* smtp_err;
	GearySmtpClientSession* _tmp12_;
	GearyCredentials* _tmp13_;
	GearySmtpGreeting* _tmp14_;
	GearySmtpGreeting* _tmp15_;
	GError* login_err;
	GError* _tmp16_;
	const gchar* _tmp17_;
	GError* _tmp18_;
	GError* _tmp19_;
	GError* _tmp20_;
	GearyRFC822MailboxAddress* reverse_path;
	GearyRFC822MailboxAddress* _tmp21_;
	GearyRFC822MailboxAddress* _tmp22_;
	GearyRFC822MailboxAddress* _tmp23_;
	GearyRFC822MailboxAddress* _tmp24_;
	GearyRFC822MailboxAddresses* _tmp25_;
	GearyRFC822MailboxAddresses* _tmp26_;
	GearyRFC822MailboxAddresses* _from_list;
	GearyRFC822MailboxAddresses* _tmp27_;
	GearyRFC822MailboxAddresses* _tmp28_;
	gint _from_size;
	GearyRFC822MailboxAddresses* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	gint _from_index;
	gint _tmp32_;
	gint _tmp33_;
	GearyRFC822MailboxAddress* from;
	GearyRFC822MailboxAddresses* _tmp34_;
	GearyRFC822MailboxAddress* _tmp35_;
	GearyAccountInformation* _tmp36_;
	GearyAccountInformation* _tmp37_;
	GearyRFC822MailboxAddress* _tmp38_;
	GearyRFC822MailboxAddress* _tmp39_;
	GearyRFC822MailboxAddress* _tmp40_;
	GearyRFC822MailboxAddress* _tmp41_;
	GearyAccountInformation* _tmp42_;
	GearyAccountInformation* _tmp43_;
	GearyRFC822MailboxAddress* _tmp44_;
	GearyRFC822MailboxAddress* _tmp45_;
	GearySmtpClientSession* _tmp46_;
	GearyRFC822MailboxAddress* _tmp47_;
	GError* send_err;
	GError* _tmp48_;
	const gchar* _tmp49_;
	GError* _tmp50_;
	GError* _tmp51_;
	GearySmtpClientSession* _tmp52_;
	GearySmtpResponse* _tmp53_;
	GearySmtpResponse* _tmp54_;
	GError* err;
	GearySmtpClientSession* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	GError* _tmp58_;
	const gchar* _tmp59_;
	GearyProgressMonitor* _tmp60_;
	GError* _tmp61_;
	GError* _tmp62_;
	GError* _tmp63_;
	GError* _inner_error0_;
};

struct _GearySmtpClientServiceSaveSentMailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientService* self;
	GearyEmail* message;
	GCancellable* cancellable;
	GearyFolder* _tmp0_;
	GearyAccount* _tmp1_;
	GearyAccount* _tmp2_;
	GearyFolder* _tmp3_;
	GearyFolderSupportCreate* create;
	GearyFolderSupportCreate* _tmp4_;
	GearyFolderSupportCreate* _tmp5_;
	GError* _tmp6_;
	GearyRFC822Message* raw;
	GearyRFC822Message* _tmp7_;
	gboolean open;
	GearyFolderSupportCreate* _tmp8_;
	GearyFolderSupportCreate* _tmp9_;
	GearyRFC822Message* _tmp10_;
	GearyEmailIdentifier* _tmp11_;
	GearyEmailIdentifier* _tmp12_;
	GearyFolderSupportCreate* _tmp13_;
	GError* _inner_error1_;
	GearyFolderSupportCreate* _tmp14_;
	GError* e;
	GearyFolderSupportCreate* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GError* _tmp18_;
	const gchar* _tmp19_;
	GError* _inner_error0_;
};

struct _GearySmtpClientServiceSyncSentMailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientService* self;
	GearyEmail* message;
	GCancellable* cancellable;
	GearyFolder* sent;
	GearyAccount* _tmp0_;
	GearyAccount* _tmp1_;
	GearyFolder* _tmp2_;
	GearyFolder* _tmp3_;
	gboolean open;
	GearyFolder* _tmp4_;
	GearyFolder* _tmp5_;
	GearyFolder* _tmp6_;
	GError* _inner_error1_;
	GearyFolder* _tmp7_;
	GError* e;
	GearyFolder* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_;
};

struct _GearySmtpClientServiceWaitForMessageData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GearySmtpClientService* self;
	GearyFolder* location;
	GearyEmail* sent;
	GCancellable* cancellable;
	GearyRFC822MessageID* id;
	GearyRFC822MessageID* _tmp0_;
	GearyRFC822MessageID* _tmp1_;
	GearyRFC822MessageID* _tmp2_;
	GearyRFC822MessageID* _tmp3_;
	gint i;
	gboolean _tmp4_;
	gint _tmp5_;
	GeeList* list;
	GeeList* _tmp6_;
	gboolean _tmp7_;
	GeeList* _tmp8_;
	GeeList* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GearyEmail* listed;
	GeeList* _tmp12_;
	gpointer _tmp13_;
	gboolean _tmp14_;
	GearyEmail* _tmp15_;
	GearyRFC822MessageID* _tmp16_;
	GearyRFC822MessageID* _tmp17_;
	GearyEmail* _tmp18_;
	GearyRFC822MessageID* _tmp19_;
	GearyRFC822MessageID* _tmp20_;
	GearyRFC822MessageID* _tmp21_;
	GError* _inner_error0_;
};

static gint GearySmtpClientService_private_offset;
static gpointer geary_smtp_client_service_parent_class = NULL;

static gchar* geary_smtp_client_service_email_subject (GearyEmailHeaderSet* email);
VALA_EXTERN void geary_smtp_client_service_set_outbox (GearySmtpClientService* self,
                                           GearyOutboxFolder* value);
static void geary_smtp_client_service_set_sending_monitor (GearySmtpClientService* self,
                                                    GearyProgressMonitor* value);
static GearyAccount* geary_smtp_client_service_get_owner (GearySmtpClientService* self);
static void geary_smtp_client_service_real_start_data_free (gpointer _data);
static void geary_smtp_client_service_real_start (GearyClientService* base,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static gboolean geary_smtp_client_service_real_start_co (GearySmtpClientServiceStartData* _data_);
static void geary_smtp_client_service_start_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void geary_smtp_client_service_fill_outbox_queue (GearySmtpClientService* self,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static void geary_smtp_client_service_fill_outbox_queue_finish (GearySmtpClientService* self,
                                                         GAsyncResult* _res_);
static void geary_smtp_client_service_real_stop_data_free (gpointer _data);
static void geary_smtp_client_service_real_stop (GearyClientService* base,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static gboolean geary_smtp_client_service_real_stop_co (GearySmtpClientServiceStopData* _data_);
static void geary_smtp_client_service_stop_postie (GearySmtpClientService* self);
static gboolean _geary_smtp_client_service_real_stop_co_gsource_func (gpointer self);
static void geary_smtp_client_service_stop_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static void geary_smtp_client_service_send_email_data_free (gpointer _data);
static gboolean geary_smtp_client_service_send_email_co (GearySmtpClientServiceSendEmailData* _data_);
static void geary_smtp_client_service_send_email_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void geary_smtp_client_service_save_email_data_free (gpointer _data);
static gboolean geary_smtp_client_service_save_email_co (GearySmtpClientServiceSaveEmailData* _data_);
static void geary_smtp_client_service_save_email_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void geary_smtp_client_service_real_became_reachable (GearyClientService* base);
static void geary_smtp_client_service_start_postie (GearySmtpClientService* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
static void geary_smtp_client_service_start_postie_finish (GearySmtpClientService* self,
                                                    GAsyncResult* _res_);
static void geary_smtp_client_service_real_became_unreachable (GearyClientService* base);
static void geary_smtp_client_service_start_postie_data_free (gpointer _data);
static gboolean geary_smtp_client_service_start_postie_co (GearySmtpClientServiceStartPostieData* _data_);
static void geary_smtp_client_service_start_postie_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void geary_smtp_client_service_process_email (GearySmtpClientService* self,
                                              GearyEmailIdentifier* id,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static void geary_smtp_client_service_process_email_finish (GearySmtpClientService* self,
                                                     GAsyncResult* _res_,
                                                     GError** error);
static void geary_smtp_client_service_fill_outbox_queue_data_free (gpointer _data);
static gboolean geary_smtp_client_service_fill_outbox_queue_co (GearySmtpClientServiceFillOutboxQueueData* _data_);
static void geary_smtp_client_service_fill_outbox_queue_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static void geary_smtp_client_service_process_email_data_free (gpointer _data);
static gboolean geary_smtp_client_service_process_email_co (GearySmtpClientServiceProcessEmailData* _data_);
static void geary_smtp_client_service_process_email_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void geary_smtp_client_service_send_email_internal (GearySmtpClientService* self,
                                                    GearyRFC822Message* rfc822,
                                                    GCancellable* cancellable,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
static void geary_smtp_client_service_send_email_internal_finish (GearySmtpClientService* self,
                                                           GAsyncResult* _res_,
                                                           GError** error);
static void geary_smtp_client_service_save_sent_mail (GearySmtpClientService* self,
                                               GearyEmail* message,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static void geary_smtp_client_service_save_sent_mail_finish (GearySmtpClientService* self,
                                                      GAsyncResult* _res_,
                                                      GError** error);
static void geary_smtp_client_service_sync_sent_mail (GearySmtpClientService* self,
                                               GearyEmail* message,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static void geary_smtp_client_service_sync_sent_mail_finish (GearySmtpClientService* self,
                                                      GAsyncResult* _res_,
                                                      GError** error);
static void geary_smtp_client_service_send_email_internal_data_free (gpointer _data);
static gboolean geary_smtp_client_service_send_email_internal_co (GearySmtpClientServiceSendEmailInternalData* _data_);
VALA_EXTERN void geary_smtp_client_session_set_logging_parent (GearySmtpClientSession* self,
                                                   GearyLoggingSource* parent);
static void geary_smtp_client_service_send_email_internal_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void geary_smtp_client_service_save_sent_mail_data_free (gpointer _data);
static gboolean geary_smtp_client_service_save_sent_mail_co (GearySmtpClientServiceSaveSentMailData* _data_);
static void geary_smtp_client_service_save_sent_mail_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
static void geary_smtp_client_service_wait_for_message (GearySmtpClientService* self,
                                                 GearyFolder* location,
                                                 GearyEmail* sent,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void geary_smtp_client_service_wait_for_message_finish (GearySmtpClientService* self,
                                                        GAsyncResult* _res_,
                                                        GError** error);
static void geary_smtp_client_service_sync_sent_mail_data_free (gpointer _data);
static gboolean geary_smtp_client_service_sync_sent_mail_co (GearySmtpClientServiceSyncSentMailData* _data_);
static void geary_smtp_client_service_sync_sent_mail_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
static void geary_smtp_client_service_wait_for_message_data_free (gpointer _data);
static gboolean geary_smtp_client_service_wait_for_message_co (GearySmtpClientServiceWaitForMessageData* _data_);
static void geary_smtp_client_service_wait_for_message_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static gboolean _geary_smtp_client_service_wait_for_message_co_gsource_func (gpointer self);
static void geary_smtp_client_service_finalize (GObject * obj);
static GType geary_smtp_client_service_get_type_once (void);
static void _vala_geary_smtp_client_service_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_geary_smtp_client_service_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

static inline gpointer
geary_smtp_client_service_get_instance_private (GearySmtpClientService* self)
{
	return G_STRUCT_MEMBER_P (self, GearySmtpClientService_private_offset);
}

static gchar*
geary_smtp_client_service_email_subject (GearyEmailHeaderSet* email)
{
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GearyRFC822Subject* _tmp2_;
	GearyRFC822Subject* _tmp3_;
	gchar* result;
#line 27 "../src/engine/smtp/smtp-client-service.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL_HEADER_SET (email), NULL);
#line 28 "../src/engine/smtp/smtp-client-service.vala"
	_tmp2_ = geary_email_header_set_get_subject (email);
#line 28 "../src/engine/smtp/smtp-client-service.vala"
	_tmp3_ = _tmp2_;
#line 28 "../src/engine/smtp/smtp-client-service.vala"
	if (_tmp3_ != NULL) {
#line 681 "smtp-client-service.c"
		GearyRFC822Subject* _tmp4_;
		GearyRFC822Subject* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 29 "../src/engine/smtp/smtp-client-service.vala"
		_tmp4_ = geary_email_header_set_get_subject (email);
#line 29 "../src/engine/smtp/smtp-client-service.vala"
		_tmp5_ = _tmp4_;
#line 29 "../src/engine/smtp/smtp-client-service.vala"
		_tmp6_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 29 "../src/engine/smtp/smtp-client-service.vala"
		_tmp7_ = _tmp6_;
#line 29 "../src/engine/smtp/smtp-client-service.vala"
		_tmp1_ = !geary_string_is_empty (_tmp7_);
#line 29 "../src/engine/smtp/smtp-client-service.vala"
		_g_free0 (_tmp7_);
#line 698 "smtp-client-service.c"
	} else {
#line 29 "../src/engine/smtp/smtp-client-service.vala"
		_tmp1_ = FALSE;
#line 702 "smtp-client-service.c"
	}
#line 28 "../src/engine/smtp/smtp-client-service.vala"
	if (_tmp1_) {
#line 706 "smtp-client-service.c"
		GearyRFC822Subject* _tmp8_;
		GearyRFC822Subject* _tmp9_;
		gchar* _tmp10_;
#line 30 "../src/engine/smtp/smtp-client-service.vala"
		_tmp8_ = geary_email_header_set_get_subject (email);
#line 30 "../src/engine/smtp/smtp-client-service.vala"
		_tmp9_ = _tmp8_;
#line 30 "../src/engine/smtp/smtp-client-service.vala"
		_tmp10_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 30 "../src/engine/smtp/smtp-client-service.vala"
		_g_free0 (_tmp0_);
#line 30 "../src/engine/smtp/smtp-client-service.vala"
		_tmp0_ = _tmp10_;
#line 720 "smtp-client-service.c"
	} else {
		gchar* _tmp11_;
#line 31 "../src/engine/smtp/smtp-client-service.vala"
		_tmp11_ = g_strdup ("(no subject)");
#line 31 "../src/engine/smtp/smtp-client-service.vala"
		_g_free0 (_tmp0_);
#line 31 "../src/engine/smtp/smtp-client-service.vala"
		_tmp0_ = _tmp11_;
#line 729 "smtp-client-service.c"
	}
#line 28 "../src/engine/smtp/smtp-client-service.vala"
	result = _tmp0_;
#line 28 "../src/engine/smtp/smtp-client-service.vala"
	return result;
#line 735 "smtp-client-service.c"
}

GearyOutboxFolder*
geary_smtp_client_service_get_outbox (GearySmtpClientService* self)
{
	GearyOutboxFolder* result;
	GearyOutboxFolder* _tmp0_;
#line 36 "../src/engine/smtp/smtp-client-service.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self), NULL);
#line 36 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = self->priv->_outbox;
#line 36 "../src/engine/smtp/smtp-client-service.vala"
	result = _tmp0_;
#line 36 "../src/engine/smtp/smtp-client-service.vala"
	return result;
#line 751 "smtp-client-service.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../src/engine/smtp/smtp-client-service.vala"
	return self ? g_object_ref (self) : NULL;
#line 759 "smtp-client-service.c"
}

void
geary_smtp_client_service_set_outbox (GearySmtpClientService* self,
                                      GearyOutboxFolder* value)
{
	GearyOutboxFolder* old_value;
#line 36 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 36 "../src/engine/smtp/smtp-client-service.vala"
	old_value = geary_smtp_client_service_get_outbox (self);
#line 36 "../src/engine/smtp/smtp-client-service.vala"
	if (old_value != value) {
#line 773 "smtp-client-service.c"
		GearyOutboxFolder* _tmp0_;
#line 36 "../src/engine/smtp/smtp-client-service.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 36 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (self->priv->_outbox);
#line 36 "../src/engine/smtp/smtp-client-service.vala"
		self->priv->_outbox = _tmp0_;
#line 36 "../src/engine/smtp/smtp-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_smtp_client_service_properties[GEARY_SMTP_CLIENT_SERVICE_OUTBOX_PROPERTY]);
#line 783 "smtp-client-service.c"
	}
}

GearyProgressMonitor*
geary_smtp_client_service_get_sending_monitor (GearySmtpClientService* self)
{
	GearyProgressMonitor* result;
	GearyProgressMonitor* _tmp0_;
#line 40 "../src/engine/smtp/smtp-client-service.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self), NULL);
#line 40 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = self->priv->_sending_monitor;
#line 40 "../src/engine/smtp/smtp-client-service.vala"
	result = _tmp0_;
#line 40 "../src/engine/smtp/smtp-client-service.vala"
	return result;
#line 800 "smtp-client-service.c"
}

static void
geary_smtp_client_service_set_sending_monitor (GearySmtpClientService* self,
                                               GearyProgressMonitor* value)
{
	GearyProgressMonitor* old_value;
#line 41 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 41 "../src/engine/smtp/smtp-client-service.vala"
	old_value = geary_smtp_client_service_get_sending_monitor (self);
#line 41 "../src/engine/smtp/smtp-client-service.vala"
	if (old_value != value) {
#line 814 "smtp-client-service.c"
		GearyProgressMonitor* _tmp0_;
#line 41 "../src/engine/smtp/smtp-client-service.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (self->priv->_sending_monitor);
#line 41 "../src/engine/smtp/smtp-client-service.vala"
		self->priv->_sending_monitor = _tmp0_;
#line 41 "../src/engine/smtp/smtp-client-service.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_smtp_client_service_properties[GEARY_SMTP_CLIENT_SERVICE_SENDING_MONITOR_PROPERTY]);
#line 824 "smtp-client-service.c"
	}
}

static const gchar*
geary_smtp_client_service_real_get_logging_domain (GearyClientService* base)
{
	const gchar* result;
	GearySmtpClientService* self;
#line 47 "../src/engine/smtp/smtp-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SMTP_TYPE_CLIENT_SERVICE, GearySmtpClientService);
#line 47 "../src/engine/smtp/smtp-client-service.vala"
	result = GEARY_SMTP_CLIENT_SERVICE_LOGGING_DOMAIN;
#line 47 "../src/engine/smtp/smtp-client-service.vala"
	return result;
#line 839 "smtp-client-service.c"
}

static GearyAccount*
geary_smtp_client_service_get_owner (GearySmtpClientService* self)
{
	GearyAccount* result;
	GearyOutboxFolder* _tmp0_;
	GearyAccount* _tmp1_;
	GearyAccount* _tmp2_;
#line 50 "../src/engine/smtp/smtp-client-service.vala"
	g_return_val_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self), NULL);
#line 50 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = self->priv->_outbox;
#line 50 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_FOLDER, GearyFolder));
#line 50 "../src/engine/smtp/smtp-client-service.vala"
	_tmp2_ = _tmp1_;
#line 50 "../src/engine/smtp/smtp-client-service.vala"
	result = _tmp2_;
#line 50 "../src/engine/smtp/smtp-client-service.vala"
	return result;
#line 861 "smtp-client-service.c"
}

GearySmtpClientService*
geary_smtp_client_service_construct (GType object_type,
                                     GearyAccountInformation* account,
                                     GearyServiceInformation* service,
                                     GearyEndpoint* remote)
{
	GearySmtpClientService * self = NULL;
#line 63 "../src/engine/smtp/smtp-client-service.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account), NULL);
#line 63 "../src/engine/smtp/smtp-client-service.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (service), NULL);
#line 63 "../src/engine/smtp/smtp-client-service.vala"
	g_return_val_if_fail (GEARY_IS_ENDPOINT (remote), NULL);
#line 66 "../src/engine/smtp/smtp-client-service.vala"
	self = (GearySmtpClientService*) geary_client_service_construct (object_type, account, service, remote);
#line 63 "../src/engine/smtp/smtp-client-service.vala"
	return self;
#line 881 "smtp-client-service.c"
}

GearySmtpClientService*
geary_smtp_client_service_new (GearyAccountInformation* account,
                               GearyServiceInformation* service,
                               GearyEndpoint* remote)
{
#line 63 "../src/engine/smtp/smtp-client-service.vala"
	return geary_smtp_client_service_construct (GEARY_SMTP_TYPE_CLIENT_SERVICE, account, service, remote);
#line 891 "smtp-client-service.c"
}

static void
geary_smtp_client_service_real_start_data_free (gpointer _data)
{
	GearySmtpClientServiceStartData* _data_;
	_data_ = _data;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_slice_free (GearySmtpClientServiceStartData, _data_);
#line 905 "smtp-client-service.c"
}

static void
geary_smtp_client_service_real_start (GearyClientService* base,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	GearySmtpClientService * self;
	GearySmtpClientServiceStartData* _data_;
	GearySmtpClientService* _tmp0_;
	GCancellable* _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SMTP_TYPE_CLIENT_SERVICE, GearySmtpClientService);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_slice_new0 (GearySmtpClientServiceStartData);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_service_real_start_data_free);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self = _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->cancellable = _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_real_start_co (_data_);
#line 940 "smtp-client-service.c"
}

static void
geary_smtp_client_service_start_finish (GearyClientService* base,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	GearySmtpClientServiceStartData* _data_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	if (NULL == _data_) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		return;
#line 955 "smtp-client-service.c"
	}
}

/**
     * Starts the manager opening IMAP client sessions.
     */
static void
geary_smtp_client_service_start_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	GearySmtpClientServiceStartData* _data_;
#line 74 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = _user_data_;
#line 74 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_source_object_ = source_object;
#line 74 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_res_ = _res_;
#line 74 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_real_start_co (_data_);
#line 976 "smtp-client-service.c"
}

static gboolean
geary_smtp_client_service_real_start_co (GearySmtpClientServiceStartData* _data_)
{
#line 72 "../src/engine/smtp/smtp-client-service.vala"
	switch (_data_->_state_) {
#line 72 "../src/engine/smtp/smtp-client-service.vala"
		case 0:
#line 986 "smtp-client-service.c"
		goto _state_0;
#line 72 "../src/engine/smtp/smtp-client-service.vala"
		case 1:
#line 990 "smtp-client-service.c"
		goto _state_1;
#line 72 "../src/engine/smtp/smtp-client-service.vala"
		case 2:
#line 994 "smtp-client-service.c"
		goto _state_2;
		default:
#line 72 "../src/engine/smtp/smtp-client-service.vala"
		g_assert_not_reached ();
#line 999 "smtp-client-service.c"
	}
	_state_0:
#line 74 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp0_ = _data_->self->priv->_outbox;
#line 74 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_state_ = 1;
#line 74 "../src/engine/smtp/smtp-client-service.vala"
	geary_folder_open_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_TYPE_FOLDER, GearyFolder), GEARY_FOLDER_OPEN_FLAGS_NONE, _data_->cancellable, geary_smtp_client_service_start_ready, _data_);
#line 74 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 1010 "smtp-client-service.c"
	_state_1:
#line 74 "../src/engine/smtp/smtp-client-service.vala"
	geary_folder_open_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error0_);
#line 74 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 74 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 74 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 74 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 1022 "smtp-client-service.c"
	}
#line 75 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_state_ = 2;
#line 75 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_fill_outbox_queue (_data_->self, _data_->cancellable, geary_smtp_client_service_start_ready, _data_);
#line 75 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 1030 "smtp-client-service.c"
	_state_2:
#line 75 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_fill_outbox_queue_finish (_data_->self, _data_->_res_);
#line 76 "../src/engine/smtp/smtp-client-service.vala"
	geary_client_service_notify_started (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 72 "../src/engine/smtp/smtp-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 72 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_state_ != 0) {
#line 72 "../src/engine/smtp/smtp-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 72 "../src/engine/smtp/smtp-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1044 "smtp-client-service.c"
		}
	}
#line 72 "../src/engine/smtp/smtp-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 72 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 1051 "smtp-client-service.c"
}

static void
geary_smtp_client_service_real_stop_data_free (gpointer _data)
{
	GearySmtpClientServiceStopData* _data_;
	_data_ = _data;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_slice_free (GearySmtpClientServiceStopData, _data_);
#line 1065 "smtp-client-service.c"
}

static void
geary_smtp_client_service_real_stop (GearyClientService* base,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	GearySmtpClientService * self;
	GearySmtpClientServiceStopData* _data_;
	GearySmtpClientService* _tmp0_;
	GCancellable* _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SMTP_TYPE_CLIENT_SERVICE, GearySmtpClientService);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_slice_new0 (GearySmtpClientServiceStopData);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_service_real_stop_data_free);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self = _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->cancellable = _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_real_stop_co (_data_);
#line 1100 "smtp-client-service.c"
}

static void
geary_smtp_client_service_stop_finish (GearyClientService* base,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	GearySmtpClientServiceStopData* _data_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	if (NULL == _data_) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		return;
#line 1115 "smtp-client-service.c"
	}
}

/**
     * Stops the manager running, closing any existing sessions.
     */
static gboolean
_geary_smtp_client_service_real_stop_co_gsource_func (gpointer self)
{
	gboolean result;
	result = geary_smtp_client_service_real_stop_co (self);
#line 90 "../src/engine/smtp/smtp-client-service.vala"
	return result;
#line 1129 "smtp-client-service.c"
}

static void
geary_smtp_client_service_stop_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	GearySmtpClientServiceStopData* _data_;
#line 93 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = _user_data_;
#line 93 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_source_object_ = source_object;
#line 93 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_res_ = _res_;
#line 93 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_real_stop_co (_data_);
#line 1146 "smtp-client-service.c"
}

static gboolean
geary_smtp_client_service_real_stop_co (GearySmtpClientServiceStopData* _data_)
{
#line 82 "../src/engine/smtp/smtp-client-service.vala"
	switch (_data_->_state_) {
#line 82 "../src/engine/smtp/smtp-client-service.vala"
		case 0:
#line 1156 "smtp-client-service.c"
		goto _state_0;
#line 82 "../src/engine/smtp/smtp-client-service.vala"
		case 1:
#line 1160 "smtp-client-service.c"
		goto _state_1;
#line 82 "../src/engine/smtp/smtp-client-service.vala"
		case 2:
#line 1164 "smtp-client-service.c"
		goto _state_2;
		default:
#line 82 "../src/engine/smtp/smtp-client-service.vala"
		g_assert_not_reached ();
#line 1169 "smtp-client-service.c"
	}
	_state_0:
#line 84 "../src/engine/smtp/smtp-client-service.vala"
	geary_client_service_notify_stopped (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 85 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_stop_postie (_data_->self);
#line 89 "../src/engine/smtp/smtp-client-service.vala"
	while (TRUE) {
#line 89 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp0_ = _data_->self->priv->queue_cancellable;
#line 89 "../src/engine/smtp/smtp-client-service.vala"
		if (!(_data_->_tmp0_ != NULL)) {
#line 89 "../src/engine/smtp/smtp-client-service.vala"
			break;
#line 1184 "smtp-client-service.c"
		}
#line 90 "../src/engine/smtp/smtp-client-service.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _geary_smtp_client_service_real_stop_co_gsource_func, _data_, NULL);
#line 91 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_state_ = 1;
#line 91 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 1192 "smtp-client-service.c"
		_state_1:
		;
	}
#line 93 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp1_ = _data_->self->priv->_outbox;
#line 93 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_state_ = 2;
#line 93 "../src/engine/smtp/smtp-client-service.vala"
	geary_folder_close_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_TYPE_FOLDER, GearyFolder), _data_->cancellable, geary_smtp_client_service_stop_ready, _data_);
#line 93 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 1204 "smtp-client-service.c"
	_state_2:
#line 93 "../src/engine/smtp/smtp-client-service.vala"
	geary_folder_close_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error0_);
#line 93 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 93 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 93 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 93 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 1216 "smtp-client-service.c"
	}
#line 82 "../src/engine/smtp/smtp-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 82 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_state_ != 0) {
#line 82 "../src/engine/smtp/smtp-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 82 "../src/engine/smtp/smtp-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1226 "smtp-client-service.c"
		}
	}
#line 82 "../src/engine/smtp/smtp-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 82 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 1233 "smtp-client-service.c"
}

static void
geary_smtp_client_service_send_email_data_free (gpointer _data)
{
	GearySmtpClientServiceSendEmailData* _data_;
	_data_ = _data;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->composed);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_slice_free (GearySmtpClientServiceSendEmailData, _data_);
#line 1249 "smtp-client-service.c"
}

void
geary_smtp_client_service_send_email (GearySmtpClientService* self,
                                      GearyComposedEmail* composed,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	GearySmtpClientServiceSendEmailData* _data_;
	GearySmtpClientService* _tmp0_;
	GearyComposedEmail* _tmp1_;
	GCancellable* _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_IS_COMPOSED_EMAIL (composed));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_slice_new0 (GearySmtpClientServiceSendEmailData);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_service_send_email_data_free);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self = _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = _g_object_ref0 (composed);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->composed);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->composed = _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->cancellable = _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_send_email_co (_data_);
#line 1293 "smtp-client-service.c"
}

void
geary_smtp_client_service_send_email_finish (GearySmtpClientService* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	GearySmtpClientServiceSendEmailData* _data_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	if (NULL == _data_) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		return;
#line 1308 "smtp-client-service.c"
	}
}

/**
     * Saves and queues email for immediate delivery.
     *
     * This is a convenience method that calls {@link save_email} then
     * {@link queue_email} with the resulting id.
     */
static void
geary_smtp_client_service_send_email_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	GearySmtpClientServiceSendEmailData* _data_;
#line 105 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = _user_data_;
#line 105 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_source_object_ = source_object;
#line 105 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_res_ = _res_;
#line 105 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_send_email_co (_data_);
#line 1332 "smtp-client-service.c"
}

static gboolean
geary_smtp_client_service_send_email_co (GearySmtpClientServiceSendEmailData* _data_)
{
#line 102 "../src/engine/smtp/smtp-client-service.vala"
	switch (_data_->_state_) {
#line 102 "../src/engine/smtp/smtp-client-service.vala"
		case 0:
#line 1342 "smtp-client-service.c"
		goto _state_0;
#line 102 "../src/engine/smtp/smtp-client-service.vala"
		case 1:
#line 1346 "smtp-client-service.c"
		goto _state_1;
		default:
#line 102 "../src/engine/smtp/smtp-client-service.vala"
		g_assert_not_reached ();
#line 1351 "smtp-client-service.c"
	}
	_state_0:
#line 105 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_state_ = 1;
#line 105 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_save_email (_data_->self, _data_->composed, _data_->cancellable, geary_smtp_client_service_send_email_ready, _data_);
#line 105 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 1360 "smtp-client-service.c"
	_state_1:
#line 105 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp1_ = geary_smtp_client_service_save_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 105 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp0_ = _data_->_tmp1_;
#line 105 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 105 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 105 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 105 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 1374 "smtp-client-service.c"
	}
#line 105 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_queue_email (_data_->self, _data_->_tmp0_);
#line 102 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 102 "../src/engine/smtp/smtp-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 102 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_state_ != 0) {
#line 102 "../src/engine/smtp/smtp-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 102 "../src/engine/smtp/smtp-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1388 "smtp-client-service.c"
		}
	}
#line 102 "../src/engine/smtp/smtp-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 102 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 1395 "smtp-client-service.c"
}

static void
geary_smtp_client_service_save_email_data_free (gpointer _data)
{
	GearySmtpClientServiceSaveEmailData* _data_;
	_data_ = _data;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->composed);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->result);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_slice_free (GearySmtpClientServiceSaveEmailData, _data_);
#line 1413 "smtp-client-service.c"
}

void
geary_smtp_client_service_save_email (GearySmtpClientService* self,
                                      GearyComposedEmail* composed,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	GearySmtpClientServiceSaveEmailData* _data_;
	GearySmtpClientService* _tmp0_;
	GearyComposedEmail* _tmp1_;
	GCancellable* _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_IS_COMPOSED_EMAIL (composed));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_slice_new0 (GearySmtpClientServiceSaveEmailData);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_service_save_email_data_free);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self = _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = _g_object_ref0 (composed);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->composed);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->composed = _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->cancellable = _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_save_email_co (_data_);
#line 1457 "smtp-client-service.c"
}

GearyEmailIdentifier*
geary_smtp_client_service_save_email_finish (GearySmtpClientService* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	GearyEmailIdentifier* result;
	GearySmtpClientServiceSaveEmailData* _data_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	if (NULL == _data_) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		return NULL;
#line 1473 "smtp-client-service.c"
	}
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	result = _data_->result;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->result = NULL;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	return result;
#line 1481 "smtp-client-service.c"
}

/**
     * Saves a composed email in the outbox.
     *
     * This sets a suitable MessageID header for the message, then
     * saves the updated message in {@link outbox}. Returns the
     * identifier for the saved email, suitable for use with {@link
     * queue_email}.
     *
     * @see send_email
     */
static void
geary_smtp_client_service_save_email_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	GearySmtpClientServiceSaveEmailData* _data_;
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = _user_data_;
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_source_object_ = source_object;
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_res_ = _res_;
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_save_email_co (_data_);
#line 1508 "smtp-client-service.c"
}

static gboolean
geary_smtp_client_service_save_email_co (GearySmtpClientServiceSaveEmailData* _data_)
{
#line 118 "../src/engine/smtp/smtp-client-service.vala"
	switch (_data_->_state_) {
#line 118 "../src/engine/smtp/smtp-client-service.vala"
		case 0:
#line 1518 "smtp-client-service.c"
		goto _state_0;
#line 118 "../src/engine/smtp/smtp-client-service.vala"
		case 1:
#line 1522 "smtp-client-service.c"
		goto _state_1;
#line 118 "../src/engine/smtp/smtp-client-service.vala"
		case 2:
#line 1526 "smtp-client-service.c"
		goto _state_2;
		default:
#line 118 "../src/engine/smtp/smtp-client-service.vala"
		g_assert_not_reached ();
#line 1531 "smtp-client-service.c"
	}
	_state_0:
#line 121 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp0_ = geary_smtp_client_service_email_subject (G_TYPE_CHECK_INSTANCE_CAST (_data_->composed, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 121 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 121 "../src/engine/smtp/smtp-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Saving composed email: %s", _data_->_tmp1_);
#line 121 "../src/engine/smtp/smtp-client-service.vala"
	_g_free0 (_data_->_tmp1_);
#line 125 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp2_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_data_->composed, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 125 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 125 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp4_ = _g_object_ref0 (_data_->_tmp3_);
#line 125 "../src/engine/smtp/smtp-client-service.vala"
	_data_->from = _data_->_tmp4_;
#line 126 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp7_ = _data_->from;
#line 126 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp7_ != NULL) {
#line 126 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp8_ = _data_->from;
#line 126 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp9_ = geary_rf_c822_mailbox_addresses_get_is_empty (_data_->_tmp8_);
#line 126 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 126 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp6_ = !_data_->_tmp10_;
#line 1562 "smtp-client-service.c"
	} else {
#line 126 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp6_ = FALSE;
#line 1566 "smtp-client-service.c"
	}
#line 126 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp6_) {
#line 127 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp11_ = _data_->from;
#line 127 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp12_ = geary_rf_c822_mailbox_addresses_get (_data_->_tmp11_, 0);
#line 127 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 127 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp14_ = geary_rf_c822_mailbox_address_get_domain (_data_->_tmp13_);
#line 127 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 127 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp5_ = _data_->_tmp15_;
#line 127 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->_tmp13_);
#line 1584 "smtp-client-service.c"
	} else {
#line 128 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp16_ = geary_client_service_get_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 128 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 128 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp18_ = geary_account_information_get_primary_mailbox (_data_->_tmp17_);
#line 128 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 128 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 128 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp21_ = geary_rf_c822_mailbox_address_get_domain (_data_->_tmp20_);
#line 128 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 128 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp5_ = _data_->_tmp22_;
#line 128 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->_tmp20_);
#line 1604 "smtp-client-service.c"
	}
#line 126 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp23_ = g_strdup (_data_->_tmp5_);
#line 126 "../src/engine/smtp/smtp-client-service.vala"
	_data_->domain = _data_->_tmp23_;
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp24_ = _data_->domain;
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp25_ = g_mime_utils_generate_message_id (_data_->_tmp24_);
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_state_ = 1;
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	geary_rf_c822_message_new_from_composed_email (_data_->composed, _data_->_tmp26_, _data_->cancellable, geary_smtp_client_service_save_email_ready, _data_);
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 1622 "smtp-client-service.c"
	_state_1:
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp27_ = geary_rf_c822_message_new_from_composed_email_finish (_data_->_res_, &_data_->_inner_error0_);
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	_g_free0 (_data_->_tmp26_);
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	_data_->rfc822 = _data_->_tmp28_;
#line 129 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 129 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 129 "../src/engine/smtp/smtp-client-service.vala"
		_g_free0 (_data_->domain);
#line 129 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->from);
#line 129 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 129 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 1644 "smtp-client-service.c"
	}
#line 134 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp29_ = _data_->self->priv->_outbox;
#line 134 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp30_ = _data_->rfc822;
#line 134 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_state_ = 2;
#line 134 "../src/engine/smtp/smtp-client-service.vala"
	geary_outbox_folder_create_email_async (_data_->_tmp29_, _data_->_tmp30_, NULL, NULL, _data_->cancellable, geary_smtp_client_service_save_email_ready, _data_);
#line 134 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 1656 "smtp-client-service.c"
	_state_2:
#line 134 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp31_ = geary_outbox_folder_create_email_finish (_data_->_tmp29_, _data_->_res_, &_data_->_inner_error0_);
#line 134 "../src/engine/smtp/smtp-client-service.vala"
	_data_->id = _data_->_tmp31_;
#line 134 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 134 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 134 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->rfc822);
#line 134 "../src/engine/smtp/smtp-client-service.vala"
		_g_free0 (_data_->domain);
#line 134 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->from);
#line 134 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 134 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 1676 "smtp-client-service.c"
	}
#line 137 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp32_ = _data_->id;
#line 137 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp33_ = geary_email_identifier_to_string (_data_->_tmp32_);
#line 137 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 137 "../src/engine/smtp/smtp-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Saved composed email as %s", _data_->_tmp34_);
#line 137 "../src/engine/smtp/smtp-client-service.vala"
	_g_free0 (_data_->_tmp34_);
#line 138 "../src/engine/smtp/smtp-client-service.vala"
	_data_->result = _data_->id;
#line 138 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->rfc822);
#line 138 "../src/engine/smtp/smtp-client-service.vala"
	_g_free0 (_data_->domain);
#line 138 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->from);
#line 138 "../src/engine/smtp/smtp-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 138 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_state_ != 0) {
#line 138 "../src/engine/smtp/smtp-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 138 "../src/engine/smtp/smtp-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1704 "smtp-client-service.c"
		}
	}
#line 138 "../src/engine/smtp/smtp-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 138 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 1711 "smtp-client-service.c"
}

/**
     * Queues an email for immediate delivery.
     *
     * The given identifier must be for {@link outbox}, for example as
     * given by {@link save_email}.
     *
     * @see send_email
     */
void
geary_smtp_client_service_queue_email (GearySmtpClientService* self,
                                       GearyEmailIdentifier* outbox_identifier)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyNonblockingQueue* _tmp2_;
#line 149 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 149 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_IS_EMAIL_IDENTIFIER (outbox_identifier));
#line 150 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = geary_email_identifier_to_string (outbox_identifier);
#line 150 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = _tmp0_;
#line 150 "../src/engine/smtp/smtp-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Queuing email for sending: %s", _tmp1_);
#line 150 "../src/engine/smtp/smtp-client-service.vala"
	_g_free0 (_tmp1_);
#line 151 "../src/engine/smtp/smtp-client-service.vala"
	_tmp2_ = self->priv->outbox_queue;
#line 151 "../src/engine/smtp/smtp-client-service.vala"
	geary_nonblocking_queue_send (_tmp2_, outbox_identifier);
#line 1745 "smtp-client-service.c"
}

/** Starts the postie delivering messages. */
static void
geary_smtp_client_service_real_became_reachable (GearyClientService* base)
{
	GearySmtpClientService * self;
#line 155 "../src/engine/smtp/smtp-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SMTP_TYPE_CLIENT_SERVICE, GearySmtpClientService);
#line 156 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_start_postie (self, NULL, NULL);
#line 1757 "smtp-client-service.c"
}

/** Stops the postie delivering. */
static void
geary_smtp_client_service_real_became_unreachable (GearyClientService* base)
{
	GearySmtpClientService * self;
#line 160 "../src/engine/smtp/smtp-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_SMTP_TYPE_CLIENT_SERVICE, GearySmtpClientService);
#line 161 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_stop_postie (self);
#line 1769 "smtp-client-service.c"
}

static void
geary_smtp_client_service_start_postie_data_free (gpointer _data)
{
	GearySmtpClientServiceStartPostieData* _data_;
	_data_ = _data;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_slice_free (GearySmtpClientServiceStartPostieData, _data_);
#line 1781 "smtp-client-service.c"
}

static void
geary_smtp_client_service_start_postie (GearySmtpClientService* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	GearySmtpClientServiceStartPostieData* _data_;
	GearySmtpClientService* _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_slice_new0 (GearySmtpClientServiceStartPostieData);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_service_start_postie_data_free);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self = _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_start_postie_co (_data_);
#line 1805 "smtp-client-service.c"
}

static void
geary_smtp_client_service_start_postie_finish (GearySmtpClientService* self,
                                               GAsyncResult* _res_)
{
	GearySmtpClientServiceStartPostieData* _data_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1815 "smtp-client-service.c"
}

/**
     * Starts delivery of messages in the queue.
     */
static void
geary_smtp_client_service_start_postie_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	GearySmtpClientServiceStartPostieData* _data_;
#line 182 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = _user_data_;
#line 182 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_source_object_ = source_object;
#line 182 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_res_ = _res_;
#line 182 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_start_postie_co (_data_);
#line 1835 "smtp-client-service.c"
}

static gboolean
geary_smtp_client_service_start_postie_co (GearySmtpClientServiceStartPostieData* _data_)
{
#line 167 "../src/engine/smtp/smtp-client-service.vala"
	switch (_data_->_state_) {
#line 167 "../src/engine/smtp/smtp-client-service.vala"
		case 0:
#line 1845 "smtp-client-service.c"
		goto _state_0;
#line 167 "../src/engine/smtp/smtp-client-service.vala"
		case 1:
#line 1849 "smtp-client-service.c"
		goto _state_1;
#line 167 "../src/engine/smtp/smtp-client-service.vala"
		case 2:
#line 1853 "smtp-client-service.c"
		goto _state_2;
		default:
#line 167 "../src/engine/smtp/smtp-client-service.vala"
		g_assert_not_reached ();
#line 1858 "smtp-client-service.c"
	}
	_state_0:
#line 168 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp0_ = _data_->self->priv->outbox_queue;
#line 168 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp1_ = geary_nonblocking_queue_get_size (_data_->_tmp0_);
#line 168 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 168 "../src/engine/smtp/smtp-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Starting outbox postie with %u messages queued", (guint) _data_->_tmp2_);
#line 169 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp3_ = _data_->self->priv->queue_cancellable;
#line 169 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp3_ != NULL) {
#line 170 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 170 "../src/engine/smtp/smtp-client-service.vala"
		if (_data_->_state_ != 0) {
#line 170 "../src/engine/smtp/smtp-client-service.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 170 "../src/engine/smtp/smtp-client-service.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1881 "smtp-client-service.c"
			}
		}
#line 170 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 170 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 1888 "smtp-client-service.c"
	}
#line 173 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp4_ = g_cancellable_new ();
#line 173 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self->priv->queue_cancellable);
#line 173 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self->priv->queue_cancellable = _data_->_tmp4_;
#line 173 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp5_ = _data_->self->priv->queue_cancellable;
#line 173 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp6_ = _g_object_ref0 (_data_->_tmp5_);
#line 173 "../src/engine/smtp/smtp-client-service.vala"
	_data_->cancellable = _data_->_tmp6_;
#line 177 "../src/engine/smtp/smtp-client-service.vala"
	while (TRUE) {
#line 177 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp7_ = _data_->cancellable;
#line 177 "../src/engine/smtp/smtp-client-service.vala"
		if (!(!g_cancellable_is_cancelled (_data_->_tmp7_))) {
#line 177 "../src/engine/smtp/smtp-client-service.vala"
			break;
#line 1910 "smtp-client-service.c"
		}
#line 179 "../src/engine/smtp/smtp-client-service.vala"
		_data_->id = NULL;
#line 180 "../src/engine/smtp/smtp-client-service.vala"
		_data_->email_handled = FALSE;
#line 1916 "smtp-client-service.c"
		{
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp9_ = _data_->self->priv->outbox_queue;
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp10_ = _data_->cancellable;
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_state_ = 1;
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			geary_nonblocking_queue_receive (_data_->_tmp9_, _data_->_tmp10_, geary_smtp_client_service_start_postie_ready, _data_);
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 1928 "smtp-client-service.c"
			_state_1:
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp11_ = geary_nonblocking_queue_receive_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error0_);
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp8_ = (GearyEmailIdentifier*) _data_->_tmp11_;
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 182 "../src/engine/smtp/smtp-client-service.vala"
				if (_data_->_inner_error0_->domain == GEARY_SMTP_ERROR) {
#line 1938 "smtp-client-service.c"
					goto __catch0_geary_smtp_error;
				}
#line 182 "../src/engine/smtp/smtp-client-service.vala"
				if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1943 "smtp-client-service.c"
					goto __catch0_g_io_error_cancelled;
				}
#line 182 "../src/engine/smtp/smtp-client-service.vala"
				if (g_error_matches (_data_->_inner_error0_, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND)) {
#line 1948 "smtp-client-service.c"
					goto __catch0_geary_engine_error_not_found;
				}
				goto __catch0_g_error;
			}
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp12_ = _data_->_tmp8_;
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp8_ = NULL;
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->id);
#line 182 "../src/engine/smtp/smtp-client-service.vala"
			_data_->id = _data_->_tmp12_;
#line 183 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp13_ = _data_->id;
#line 183 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp14_ = _data_->cancellable;
#line 183 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_state_ = 2;
#line 183 "../src/engine/smtp/smtp-client-service.vala"
			geary_smtp_client_service_process_email (_data_->self, _data_->_tmp13_, _data_->_tmp14_, geary_smtp_client_service_start_postie_ready, _data_);
#line 183 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 1971 "smtp-client-service.c"
			_state_2:
#line 183 "../src/engine/smtp/smtp-client-service.vala"
			geary_smtp_client_service_process_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 183 "../src/engine/smtp/smtp-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 183 "../src/engine/smtp/smtp-client-service.vala"
				_g_object_unref0 (_data_->_tmp8_);
#line 183 "../src/engine/smtp/smtp-client-service.vala"
				if (_data_->_inner_error0_->domain == GEARY_SMTP_ERROR) {
#line 1981 "smtp-client-service.c"
					goto __catch0_geary_smtp_error;
				}
#line 183 "../src/engine/smtp/smtp-client-service.vala"
				if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1986 "smtp-client-service.c"
					goto __catch0_g_io_error_cancelled;
				}
#line 183 "../src/engine/smtp/smtp-client-service.vala"
				if (g_error_matches (_data_->_inner_error0_, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND)) {
#line 1991 "smtp-client-service.c"
					goto __catch0_geary_engine_error_not_found;
				}
				goto __catch0_g_error;
			}
#line 184 "../src/engine/smtp/smtp-client-service.vala"
			_data_->email_handled = TRUE;
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->_tmp8_);
#line 2000 "smtp-client-service.c"
		}
		goto __finally0;
		__catch0_geary_smtp_error:
		{
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_data_->err = _data_->_inner_error0_;
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_inner_error0_ = NULL;
#line 186 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp15_ = _data_->err;
#line 186 "../src/engine/smtp/smtp-client-service.vala"
			if (g_error_matches (_data_->_tmp15_, GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_AUTHENTICATION_FAILED)) {
#line 187 "../src/engine/smtp/smtp-client-service.vala"
				geary_client_service_notify_authentication_failed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 2015 "smtp-client-service.c"
			} else {
#line 188 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp17_ = _data_->err;
#line 188 "../src/engine/smtp/smtp-client-service.vala"
				if (g_error_matches (_data_->_tmp17_, GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_STARTTLS_FAILED)) {
#line 188 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp16_ = TRUE;
#line 2023 "smtp-client-service.c"
				} else {
#line 189 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp18_ = _data_->err;
#line 189 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp16_ = g_error_matches (_data_->_tmp18_, GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_NOT_CONNECTED);
#line 2029 "smtp-client-service.c"
				}
#line 188 "../src/engine/smtp/smtp-client-service.vala"
				if (_data_->_tmp16_) {
#line 190 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp19_ = _data_->err;
#line 190 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp20_ = geary_error_context_new (_data_->_tmp19_);
#line 190 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp21_ = _data_->_tmp20_;
#line 190 "../src/engine/smtp/smtp-client-service.vala"
					geary_client_service_notify_connection_failed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService), _data_->_tmp21_);
#line 190 "../src/engine/smtp/smtp-client-service.vala"
					_g_object_unref0 (_data_->_tmp21_);
#line 2043 "smtp-client-service.c"
				} else {
#line 191 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp24_ = _data_->err;
#line 191 "../src/engine/smtp/smtp-client-service.vala"
					if (g_error_matches (_data_->_tmp24_, GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_PARSE_ERROR)) {
#line 191 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp23_ = TRUE;
#line 2051 "smtp-client-service.c"
					} else {
#line 192 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp25_ = _data_->err;
#line 192 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp23_ = g_error_matches (_data_->_tmp25_, GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_SERVER_ERROR);
#line 2057 "smtp-client-service.c"
					}
#line 191 "../src/engine/smtp/smtp-client-service.vala"
					if (_data_->_tmp23_) {
#line 191 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp22_ = TRUE;
#line 2063 "smtp-client-service.c"
					} else {
#line 193 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp26_ = _data_->err;
#line 193 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp22_ = g_error_matches (_data_->_tmp26_, GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_NOT_SUPPORTED);
#line 2069 "smtp-client-service.c"
					}
#line 191 "../src/engine/smtp/smtp-client-service.vala"
					if (_data_->_tmp22_) {
#line 194 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp27_ = _data_->err;
#line 194 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp28_ = geary_error_context_new (_data_->_tmp27_);
#line 194 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp29_ = _data_->_tmp28_;
#line 194 "../src/engine/smtp/smtp-client-service.vala"
						geary_client_service_notify_unrecoverable_error (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService), _data_->_tmp29_);
#line 194 "../src/engine/smtp/smtp-client-service.vala"
						_g_object_unref0 (_data_->_tmp29_);
#line 2083 "smtp-client-service.c"
					}
				}
			}
#line 196 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp30_ = _data_->cancellable;
#line 196 "../src/engine/smtp/smtp-client-service.vala"
			g_cancellable_cancel (_data_->_tmp30_);
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_g_error_free0 (_data_->err);
#line 2093 "smtp-client-service.c"
		}
		goto __finally0;
		__catch0_g_io_error_cancelled:
		{
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 2100 "smtp-client-service.c"
		}
		goto __finally0;
		__catch0_geary_engine_error_not_found:
		{
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_vala1_err = _data_->_inner_error0_;
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_inner_error0_ = NULL;
#line 200 "../src/engine/smtp/smtp-client-service.vala"
			_data_->email_handled = TRUE;
#line 201 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp31_ = _data_->id;
#line 201 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp32_ = geary_email_identifier_to_string (_data_->_tmp31_);
#line 201 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp33_ = _data_->_tmp32_;
#line 201 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp34_ = _data_->_vala1_err;
#line 201 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp35_ = _data_->_tmp34_->message;
#line 201 "../src/engine/smtp/smtp-client-service.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Queued email %s not found in outbox, ignoring: %s", _data_->_tmp33_, _data_->_tmp35_);
#line 201 "../src/engine/smtp/smtp-client-service.vala"
			_g_free0 (_data_->_tmp33_);
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_g_error_free0 (_data_->_vala1_err);
#line 2127 "smtp-client-service.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_vala2_err = _data_->_inner_error0_;
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_inner_error0_ = NULL;
#line 204 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp36_ = _data_->_vala2_err;
#line 204 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp37_ = geary_error_context_new (_data_->_tmp36_);
#line 204 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp38_ = _data_->_tmp37_;
#line 204 "../src/engine/smtp/smtp-client-service.vala"
			geary_client_service_notify_connection_failed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService), _data_->_tmp38_);
#line 204 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->_tmp38_);
#line 205 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp39_ = _data_->cancellable;
#line 205 "../src/engine/smtp/smtp-client-service.vala"
			g_cancellable_cancel (_data_->_tmp39_);
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_g_error_free0 (_data_->_vala2_err);
#line 2152 "smtp-client-service.c"
		}
		__finally0:
#line 181 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->id);
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->cancellable);
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 181 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 2169 "smtp-client-service.c"
		}
#line 208 "../src/engine/smtp/smtp-client-service.vala"
		if (!_data_->email_handled) {
#line 208 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp41_ = _data_->id;
#line 208 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp40_ = _data_->_tmp41_ != NULL;
#line 2177 "smtp-client-service.c"
		} else {
#line 208 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp40_ = FALSE;
#line 2181 "smtp-client-service.c"
		}
#line 208 "../src/engine/smtp/smtp-client-service.vala"
		if (_data_->_tmp40_) {
#line 210 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp42_ = _data_->self->priv->outbox_queue;
#line 210 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp43_ = _data_->id;
#line 210 "../src/engine/smtp/smtp-client-service.vala"
			geary_nonblocking_queue_send (_data_->_tmp42_, _data_->_tmp43_);
#line 2191 "smtp-client-service.c"
		}
#line 177 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->id);
#line 2195 "smtp-client-service.c"
	}
#line 214 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self->priv->queue_cancellable);
#line 214 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self->priv->queue_cancellable = NULL;
#line 215 "../src/engine/smtp/smtp-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Outbox postie exited");
#line 167 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 167 "../src/engine/smtp/smtp-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 167 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_state_ != 0) {
#line 167 "../src/engine/smtp/smtp-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 167 "../src/engine/smtp/smtp-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2213 "smtp-client-service.c"
		}
	}
#line 167 "../src/engine/smtp/smtp-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 167 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 2220 "smtp-client-service.c"
}

/**
     * Stops delivery of messages in the queue.
     */
static void
geary_smtp_client_service_stop_postie (GearySmtpClientService* self)
{
	GCancellable* _tmp0_;
#line 221 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 222 "../src/engine/smtp/smtp-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Stopping outbox postie");
#line 223 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = self->priv->queue_cancellable;
#line 223 "../src/engine/smtp/smtp-client-service.vala"
	if (_tmp0_ != NULL) {
#line 2238 "smtp-client-service.c"
		GCancellable* _tmp1_;
#line 224 "../src/engine/smtp/smtp-client-service.vala"
		_tmp1_ = self->priv->queue_cancellable;
#line 224 "../src/engine/smtp/smtp-client-service.vala"
		g_cancellable_cancel (_tmp1_);
#line 2244 "smtp-client-service.c"
	}
}

static void
geary_smtp_client_service_fill_outbox_queue_data_free (gpointer _data)
{
	GearySmtpClientServiceFillOutboxQueueData* _data_;
	_data_ = _data;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_slice_free (GearySmtpClientServiceFillOutboxQueueData, _data_);
#line 2259 "smtp-client-service.c"
}

static void
geary_smtp_client_service_fill_outbox_queue (GearySmtpClientService* self,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	GearySmtpClientServiceFillOutboxQueueData* _data_;
	GearySmtpClientService* _tmp0_;
	GCancellable* _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_slice_new0 (GearySmtpClientServiceFillOutboxQueueData);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_service_fill_outbox_queue_data_free);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self = _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->cancellable = _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_fill_outbox_queue_co (_data_);
#line 2293 "smtp-client-service.c"
}

static void
geary_smtp_client_service_fill_outbox_queue_finish (GearySmtpClientService* self,
                                                    GAsyncResult* _res_)
{
	GearySmtpClientServiceFillOutboxQueueData* _data_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	if (NULL == _data_) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		return;
#line 2307 "smtp-client-service.c"
	}
}

/**
     * Loads any email in the outbox and adds them to the queue.
     */
static void
geary_smtp_client_service_fill_outbox_queue_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	GearySmtpClientServiceFillOutboxQueueData* _data_;
#line 234 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = _user_data_;
#line 234 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_source_object_ = source_object;
#line 234 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_res_ = _res_;
#line 234 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_fill_outbox_queue_co (_data_);
#line 2328 "smtp-client-service.c"
}

static gboolean
geary_smtp_client_service_fill_outbox_queue_co (GearySmtpClientServiceFillOutboxQueueData* _data_)
{
#line 231 "../src/engine/smtp/smtp-client-service.vala"
	switch (_data_->_state_) {
#line 231 "../src/engine/smtp/smtp-client-service.vala"
		case 0:
#line 2338 "smtp-client-service.c"
		goto _state_0;
#line 231 "../src/engine/smtp/smtp-client-service.vala"
		case 1:
#line 2342 "smtp-client-service.c"
		goto _state_1;
		default:
#line 231 "../src/engine/smtp/smtp-client-service.vala"
		g_assert_not_reached ();
#line 2347 "smtp-client-service.c"
	}
	_state_0:
#line 232 "../src/engine/smtp/smtp-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Filling queue");
#line 2352 "smtp-client-service.c"
	{
#line 234 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp0_ = _data_->self->priv->_outbox;
#line 234 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_state_ = 1;
#line 234 "../src/engine/smtp/smtp-client-service.vala"
		geary_folder_list_email_by_id_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_TYPE_FOLDER, GearyFolder), NULL, G_MAXINT, GEARY_EMAIL_FIELD_NONE, GEARY_FOLDER_LIST_FLAGS_OLDEST_TO_NEWEST, _data_->cancellable, geary_smtp_client_service_fill_outbox_queue_ready, _data_);
#line 234 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 2362 "smtp-client-service.c"
		_state_1:
#line 234 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp1_ = geary_folder_list_email_by_id_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error0_);
#line 234 "../src/engine/smtp/smtp-client-service.vala"
		_data_->queued = _data_->_tmp1_;
#line 234 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2370 "smtp-client-service.c"
			goto __catch0_g_error;
		}
#line 241 "../src/engine/smtp/smtp-client-service.vala"
		if (_data_->queued != NULL) {
#line 2375 "smtp-client-service.c"
			{
#line 242 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_email_list = _data_->queued;
#line 242 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp2_ = _data_->_email_list;
#line 242 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 242 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp4_ = _data_->_tmp3_;
#line 242 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_email_size = _data_->_tmp4_;
#line 242 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_email_index = -1;
#line 242 "../src/engine/smtp/smtp-client-service.vala"
				while (TRUE) {
#line 242 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_email_index = _data_->_email_index + 1;
#line 242 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp5_ = _data_->_email_index;
#line 242 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp6_ = _data_->_email_size;
#line 242 "../src/engine/smtp/smtp-client-service.vala"
					if (!(_data_->_tmp5_ < _data_->_tmp6_)) {
#line 242 "../src/engine/smtp/smtp-client-service.vala"
						break;
#line 2401 "smtp-client-service.c"
					}
#line 242 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp7_ = _data_->_email_list;
#line 242 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp8_ = gee_list_get (_data_->_tmp7_, _data_->_email_index);
#line 242 "../src/engine/smtp/smtp-client-service.vala"
					_data_->email = (GearyEmail*) _data_->_tmp8_;
#line 243 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp9_ = _data_->self->priv->outbox_queue;
#line 243 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp10_ = _data_->email;
#line 243 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp11_ = geary_email_get_id (_data_->_tmp10_);
#line 243 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp12_ = _data_->_tmp11_;
#line 243 "../src/engine/smtp/smtp-client-service.vala"
					geary_nonblocking_queue_send (_data_->_tmp9_, _data_->_tmp12_);
#line 242 "../src/engine/smtp/smtp-client-service.vala"
					_g_object_unref0 (_data_->email);
#line 2421 "smtp-client-service.c"
				}
			}
		}
#line 233 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->queued);
#line 2427 "smtp-client-service.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 233 "../src/engine/smtp/smtp-client-service.vala"
		_data_->err = _data_->_inner_error0_;
#line 233 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_inner_error0_ = NULL;
#line 247 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp13_ = _data_->err;
#line 247 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp14_ = _data_->_tmp13_->message;
#line 247 "../src/engine/smtp/smtp-client-service.vala"
		geary_logging_source_warning (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error filling queue: %s", _data_->_tmp14_);
#line 233 "../src/engine/smtp/smtp-client-service.vala"
		_g_error_free0 (_data_->err);
#line 2444 "smtp-client-service.c"
	}
	__finally0:
#line 233 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 233 "../src/engine/smtp/smtp-client-service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 233 "../src/engine/smtp/smtp-client-service.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 233 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 233 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 2457 "smtp-client-service.c"
	}
#line 231 "../src/engine/smtp/smtp-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 231 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_state_ != 0) {
#line 231 "../src/engine/smtp/smtp-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 231 "../src/engine/smtp/smtp-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2467 "smtp-client-service.c"
		}
	}
#line 231 "../src/engine/smtp/smtp-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 231 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 2474 "smtp-client-service.c"
}

static void
geary_smtp_client_service_process_email_data_free (gpointer _data)
{
	GearySmtpClientServiceProcessEmailData* _data_;
	_data_ = _data;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->id);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_slice_free (GearySmtpClientServiceProcessEmailData, _data_);
#line 2490 "smtp-client-service.c"
}

static void
geary_smtp_client_service_process_email (GearySmtpClientService* self,
                                         GearyEmailIdentifier* id,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GearySmtpClientServiceProcessEmailData* _data_;
	GearySmtpClientService* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GCancellable* _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_IS_EMAIL_IDENTIFIER (id));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_slice_new0 (GearySmtpClientServiceProcessEmailData);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_service_process_email_data_free);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self = _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = _g_object_ref0 (id);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->id);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->id = _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->cancellable = _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_process_email_co (_data_);
#line 2534 "smtp-client-service.c"
}

static void
geary_smtp_client_service_process_email_finish (GearySmtpClientService* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	GearySmtpClientServiceProcessEmailData* _data_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	if (NULL == _data_) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		return;
#line 2549 "smtp-client-service.c"
	}
}

static void
geary_smtp_client_service_process_email_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GearySmtpClientServiceProcessEmailData* _data_;
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = _user_data_;
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_source_object_ = source_object;
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_res_ = _res_;
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_process_email_co (_data_);
#line 2567 "smtp-client-service.c"
}

static gboolean
geary_smtp_client_service_process_email_co (GearySmtpClientServiceProcessEmailData* _data_)
{
#line 252 "../src/engine/smtp/smtp-client-service.vala"
	switch (_data_->_state_) {
#line 252 "../src/engine/smtp/smtp-client-service.vala"
		case 0:
#line 2577 "smtp-client-service.c"
		goto _state_0;
#line 252 "../src/engine/smtp/smtp-client-service.vala"
		case 1:
#line 2581 "smtp-client-service.c"
		goto _state_1;
#line 252 "../src/engine/smtp/smtp-client-service.vala"
		case 2:
#line 2585 "smtp-client-service.c"
		goto _state_2;
#line 252 "../src/engine/smtp/smtp-client-service.vala"
		case 3:
#line 2589 "smtp-client-service.c"
		goto _state_3;
#line 252 "../src/engine/smtp/smtp-client-service.vala"
		case 4:
#line 2593 "smtp-client-service.c"
		goto _state_4;
#line 252 "../src/engine/smtp/smtp-client-service.vala"
		case 5:
#line 2597 "smtp-client-service.c"
		goto _state_5;
#line 252 "../src/engine/smtp/smtp-client-service.vala"
		case 6:
#line 2601 "smtp-client-service.c"
		goto _state_6;
#line 252 "../src/engine/smtp/smtp-client-service.vala"
		case 7:
#line 2605 "smtp-client-service.c"
		goto _state_7;
		default:
#line 252 "../src/engine/smtp/smtp-client-service.vala"
		g_assert_not_reached ();
#line 2610 "smtp-client-service.c"
	}
	_state_0:
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp1_ = geary_client_service_get_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_state_ = 1;
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	geary_account_information_load_outgoing_credentials (_data_->_tmp2_, _data_->cancellable, geary_smtp_client_service_process_email_ready, _data_);
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 2623 "smtp-client-service.c"
	_state_1:
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp0_ = geary_account_information_load_outgoing_credentials_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 256 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 256 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 256 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 2635 "smtp-client-service.c"
	}
#line 256 "../src/engine/smtp/smtp-client-service.vala"
	if (!_data_->_tmp0_) {
#line 257 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp3_ = g_error_new_literal (GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_AUTHENTICATION_FAILED, "Credentials not loaded");
#line 257 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_inner_error0_ = _data_->_tmp3_;
#line 257 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 257 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 257 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 2649 "smtp-client-service.c"
	}
#line 260 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp4_ = _data_->self->priv->_outbox;
#line 260 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_state_ = 2;
#line 260 "../src/engine/smtp/smtp-client-service.vala"
	geary_folder_fetch_email_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, GEARY_TYPE_FOLDER, GearyFolder), _data_->id, GEARY_EMAIL_FIELD_ALL, GEARY_FOLDER_LIST_FLAGS_NONE, _data_->cancellable, geary_smtp_client_service_process_email_ready, _data_);
#line 260 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 2659 "smtp-client-service.c"
	_state_2:
#line 260 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp5_ = geary_folder_fetch_email_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error0_);
#line 260 "../src/engine/smtp/smtp-client-service.vala"
	_data_->email = _data_->_tmp5_;
#line 260 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 260 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 260 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 260 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 2673 "smtp-client-service.c"
	}
#line 264 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp6_ = _data_->email;
#line 264 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp7_ = geary_email_get_email_flags (_data_->_tmp6_);
#line 264 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 264 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp9_ = geary_email_flags_get_OUTBOX_SENT ();
#line 264 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 264 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 264 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp12_ = !geary_named_flags_contains (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), _data_->_tmp11_);
#line 264 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->_tmp11_);
#line 264 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp12_) {
#line 265 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp13_ = _data_->email;
#line 265 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp14_ = geary_email_get_message (_data_->_tmp13_, &_data_->_inner_error0_);
#line 265 "../src/engine/smtp/smtp-client-service.vala"
		_data_->message = _data_->_tmp14_;
#line 265 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 265 "../src/engine/smtp/smtp-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 265 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->email);
#line 265 "../src/engine/smtp/smtp-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 265 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 2709 "smtp-client-service.c"
		}
#line 266 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp15_ = _data_->message;
#line 266 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp16_ = geary_smtp_client_service_email_subject (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 266 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 266 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp18_ = _data_->email;
#line 266 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp19_ = geary_email_get_id (_data_->_tmp18_);
#line 266 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 266 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp21_ = geary_email_identifier_to_string (_data_->_tmp20_);
#line 266 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 266 "../src/engine/smtp/smtp-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Outbox postie: Sending \"%s\" (ID:%s)...", _data_->_tmp17_, _data_->_tmp22_);
#line 266 "../src/engine/smtp/smtp-client-service.vala"
		_g_free0 (_data_->_tmp22_);
#line 266 "../src/engine/smtp/smtp-client-service.vala"
		_g_free0 (_data_->_tmp17_);
#line 268 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp23_ = _data_->message;
#line 268 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_state_ = 3;
#line 268 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_service_send_email_internal (_data_->self, _data_->_tmp23_, _data_->cancellable, geary_smtp_client_service_process_email_ready, _data_);
#line 268 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 2741 "smtp-client-service.c"
		_state_3:
#line 268 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_service_send_email_internal_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 268 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 268 "../src/engine/smtp/smtp-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 268 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->message);
#line 268 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->email);
#line 268 "../src/engine/smtp/smtp-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 268 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 2757 "smtp-client-service.c"
		}
#line 269 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp24_ = _data_->email;
#line 269 "../src/engine/smtp/smtp-client-service.vala"
		g_signal_emit (_data_->self, geary_smtp_client_service_signals[GEARY_SMTP_CLIENT_SERVICE_EMAIL_SENT_SIGNAL], 0, _data_->_tmp24_);
#line 275 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp25_ = _data_->email;
#line 275 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp26_ = geary_email_get_id (_data_->_tmp25_);
#line 275 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp27_ = _data_->_tmp26_;
#line 275 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp28_ = geary_email_identifier_to_string (_data_->_tmp27_);
#line 275 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp29_ = _data_->_tmp28_;
#line 275 "../src/engine/smtp/smtp-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Outbox postie: Marking %s as sent", _data_->_tmp29_);
#line 275 "../src/engine/smtp/smtp-client-service.vala"
		_g_free0 (_data_->_tmp29_);
#line 276 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp30_ = geary_email_flags_new ();
#line 276 "../src/engine/smtp/smtp-client-service.vala"
		_data_->flags = _data_->_tmp30_;
#line 277 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp31_ = _data_->flags;
#line 277 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp32_ = geary_email_flags_get_OUTBOX_SENT ();
#line 277 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp33_ = _data_->_tmp32_;
#line 277 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp34_ = _data_->_tmp33_;
#line 277 "../src/engine/smtp/smtp-client-service.vala"
		geary_named_flags_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp31_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), _data_->_tmp34_);
#line 277 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->_tmp34_);
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp35_ = _data_->self->priv->_outbox;
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp36_ = _data_->email;
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp37_ = geary_email_get_id (_data_->_tmp36_);
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp38_ = _data_->_tmp37_;
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp39_ = geary_collection_single (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->_tmp38_);
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp40_ = _data_->_tmp39_;
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp41_ = _data_->flags;
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_state_ = 4;
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		geary_outbox_folder_mark_email_async (_data_->_tmp35_, _data_->_tmp40_, _data_->_tmp41_, NULL, NULL, geary_smtp_client_service_process_email_ready, _data_);
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 2813 "smtp-client-service.c"
		_state_4:
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		geary_outbox_folder_mark_email_finish (_data_->_tmp35_, _data_->_res_, &_data_->_inner_error0_);
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->_tmp40_);
#line 278 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 278 "../src/engine/smtp/smtp-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 278 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->flags);
#line 278 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->message);
#line 278 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->email);
#line 278 "../src/engine/smtp/smtp-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 278 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 2833 "smtp-client-service.c"
		}
#line 282 "../src/engine/smtp/smtp-client-service.vala"
		if (g_cancellable_is_cancelled (_data_->cancellable)) {
#line 283 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp42_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Send has been cancelled");
#line 283 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_inner_error0_ = _data_->_tmp42_;
#line 283 "../src/engine/smtp/smtp-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 283 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->flags);
#line 283 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->message);
#line 283 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->email);
#line 283 "../src/engine/smtp/smtp-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 283 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 2853 "smtp-client-service.c"
		}
#line 264 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->flags);
#line 264 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->message);
#line 2859 "smtp-client-service.c"
	}
#line 291 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp43_ = geary_client_service_get_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 291 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp44_ = _data_->_tmp43_;
#line 291 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp45_ = geary_account_information_get_save_sent (_data_->_tmp44_);
#line 291 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp46_ = _data_->_tmp45_;
#line 291 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp46_) {
#line 292 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp47_ = _data_->email;
#line 292 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp48_ = geary_email_get_id (_data_->_tmp47_);
#line 292 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp49_ = _data_->_tmp48_;
#line 292 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp50_ = geary_email_identifier_to_string (_data_->_tmp49_);
#line 292 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp51_ = _data_->_tmp50_;
#line 292 "../src/engine/smtp/smtp-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Outbox postie: Saving %s to sent mail", _data_->_tmp51_);
#line 292 "../src/engine/smtp/smtp-client-service.vala"
		_g_free0 (_data_->_tmp51_);
#line 294 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp52_ = _data_->email;
#line 294 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_state_ = 5;
#line 294 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_service_save_sent_mail (_data_->self, _data_->_tmp52_, _data_->cancellable, geary_smtp_client_service_process_email_ready, _data_);
#line 294 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 2893 "smtp-client-service.c"
		_state_5:
#line 294 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_service_save_sent_mail_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 294 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 294 "../src/engine/smtp/smtp-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 294 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->email);
#line 294 "../src/engine/smtp/smtp-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 294 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 2907 "smtp-client-service.c"
		}
	} else {
#line 296 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp53_ = _data_->email;
#line 296 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp54_ = geary_email_get_id (_data_->_tmp53_);
#line 296 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp55_ = _data_->_tmp54_;
#line 296 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp56_ = geary_email_identifier_to_string (_data_->_tmp55_);
#line 296 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp57_ = _data_->_tmp56_;
#line 296 "../src/engine/smtp/smtp-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Outbox postie: Syncing sent mail to find %s", _data_->_tmp57_);
#line 296 "../src/engine/smtp/smtp-client-service.vala"
		_g_free0 (_data_->_tmp57_);
#line 298 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp58_ = _data_->email;
#line 298 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_state_ = 6;
#line 298 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_service_sync_sent_mail (_data_->self, _data_->_tmp58_, _data_->cancellable, geary_smtp_client_service_process_email_ready, _data_);
#line 298 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 2932 "smtp-client-service.c"
		_state_6:
#line 298 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_service_sync_sent_mail_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 298 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 298 "../src/engine/smtp/smtp-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 298 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->email);
#line 298 "../src/engine/smtp/smtp-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 298 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 2946 "smtp-client-service.c"
		}
	}
#line 303 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp59_ = _data_->email;
#line 303 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp60_ = geary_email_get_id (_data_->_tmp59_);
#line 303 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp61_ = _data_->_tmp60_;
#line 303 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp62_ = geary_email_identifier_to_string (_data_->_tmp61_);
#line 303 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp63_ = _data_->_tmp62_;
#line 303 "../src/engine/smtp/smtp-client-service.vala"
	geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Outbox postie: Deleting row %s", _data_->_tmp63_);
#line 303 "../src/engine/smtp/smtp-client-service.vala"
	_g_free0 (_data_->_tmp63_);
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp64_ = _data_->self->priv->_outbox;
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp65_ = _data_->email;
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp66_ = geary_email_get_id (_data_->_tmp65_);
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp67_ = _data_->_tmp66_;
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp68_ = geary_collection_single (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->_tmp67_);
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp69_ = _data_->_tmp68_;
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_state_ = 7;
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	geary_outbox_folder_remove_email_async (_data_->_tmp64_, _data_->_tmp69_, NULL, geary_smtp_client_service_process_email_ready, _data_);
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 2981 "smtp-client-service.c"
	_state_7:
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	geary_outbox_folder_remove_email_finish (_data_->_tmp64_, _data_->_res_, &_data_->_inner_error0_);
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->_tmp69_);
#line 304 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 304 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 304 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->email);
#line 304 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 304 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 2997 "smtp-client-service.c"
	}
#line 252 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->email);
#line 252 "../src/engine/smtp/smtp-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 252 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_state_ != 0) {
#line 252 "../src/engine/smtp/smtp-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 252 "../src/engine/smtp/smtp-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3009 "smtp-client-service.c"
		}
	}
#line 252 "../src/engine/smtp/smtp-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 252 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 3016 "smtp-client-service.c"
}

static void
geary_smtp_client_service_send_email_internal_data_free (gpointer _data)
{
	GearySmtpClientServiceSendEmailInternalData* _data_;
	_data_ = _data;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->rfc822);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_slice_free (GearySmtpClientServiceSendEmailInternalData, _data_);
#line 3032 "smtp-client-service.c"
}

static void
geary_smtp_client_service_send_email_internal (GearySmtpClientService* self,
                                               GearyRFC822Message* rfc822,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	GearySmtpClientServiceSendEmailInternalData* _data_;
	GearySmtpClientService* _tmp0_;
	GearyRFC822Message* _tmp1_;
	GCancellable* _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_RF_C822_IS_MESSAGE (rfc822));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_slice_new0 (GearySmtpClientServiceSendEmailInternalData);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_service_send_email_internal_data_free);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self = _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = _g_object_ref0 (rfc822);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->rfc822);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->rfc822 = _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->cancellable = _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_send_email_internal_co (_data_);
#line 3076 "smtp-client-service.c"
}

static void
geary_smtp_client_service_send_email_internal_finish (GearySmtpClientService* self,
                                                      GAsyncResult* _res_,
                                                      GError** error)
{
	GearySmtpClientServiceSendEmailInternalData* _data_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	if (NULL == _data_) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		return;
#line 3091 "smtp-client-service.c"
	}
}

static void
geary_smtp_client_service_send_email_internal_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	GearySmtpClientServiceSendEmailInternalData* _data_;
#line 320 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = _user_data_;
#line 320 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_source_object_ = source_object;
#line 320 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_res_ = _res_;
#line 320 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_send_email_internal_co (_data_);
#line 3109 "smtp-client-service.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 323 "../src/engine/smtp/smtp-client-service.vala"
	return self ? g_error_copy (self) : NULL;
#line 3117 "smtp-client-service.c"
}

static gboolean
geary_smtp_client_service_send_email_internal_co (GearySmtpClientServiceSendEmailInternalData* _data_)
{
#line 307 "../src/engine/smtp/smtp-client-service.vala"
	switch (_data_->_state_) {
#line 307 "../src/engine/smtp/smtp-client-service.vala"
		case 0:
#line 3127 "smtp-client-service.c"
		goto _state_0;
#line 307 "../src/engine/smtp/smtp-client-service.vala"
		case 1:
#line 3131 "smtp-client-service.c"
		goto _state_1;
#line 307 "../src/engine/smtp/smtp-client-service.vala"
		case 2:
#line 3135 "smtp-client-service.c"
		goto _state_2;
#line 307 "../src/engine/smtp/smtp-client-service.vala"
		case 3:
#line 3139 "smtp-client-service.c"
		goto _state_3;
		default:
#line 307 "../src/engine/smtp/smtp-client-service.vala"
		g_assert_not_reached ();
#line 3144 "smtp-client-service.c"
	}
	_state_0:
#line 309 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp0_ = geary_client_service_get_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 309 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 309 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp2_ = geary_account_information_get_outgoing_credentials (_data_->_tmp1_);
#line 309 "../src/engine/smtp/smtp-client-service.vala"
	_data_->login = _data_->_tmp2_;
#line 310 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp4_ = _data_->login;
#line 310 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp4_ != NULL) {
#line 310 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp5_ = _data_->login;
#line 310 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp3_ = !geary_credentials_is_complete (_data_->_tmp5_);
#line 3163 "smtp-client-service.c"
	} else {
#line 310 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp3_ = FALSE;
#line 3167 "smtp-client-service.c"
	}
#line 310 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp3_) {
#line 311 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp6_ = g_error_new_literal (GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_AUTHENTICATION_FAILED, "Token not loaded");
#line 311 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_inner_error0_ = _data_->_tmp6_;
#line 311 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 311 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->login);
#line 311 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 311 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3183 "smtp-client-service.c"
	}
#line 314 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp7_ = geary_client_service_get_remote (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 314 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 314 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp9_ = geary_smtp_client_session_new (_data_->_tmp8_);
#line 314 "../src/engine/smtp/smtp-client-service.vala"
	_data_->smtp = _data_->_tmp9_;
#line 315 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp10_ = _data_->smtp;
#line 315 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_session_set_logging_parent (_data_->_tmp10_, G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 316 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp11_ = _data_->self->priv->_sending_monitor;
#line 316 "../src/engine/smtp/smtp-client-service.vala"
	geary_progress_monitor_notify_start (_data_->_tmp11_);
#line 318 "../src/engine/smtp/smtp-client-service.vala"
	_data_->smtp_err = NULL;
#line 3203 "smtp-client-service.c"
	{
#line 320 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp12_ = _data_->smtp;
#line 320 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp13_ = _data_->login;
#line 320 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_state_ = 1;
#line 320 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_session_login_async (_data_->_tmp12_, _data_->_tmp13_, _data_->cancellable, geary_smtp_client_service_send_email_internal_ready, _data_);
#line 320 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3215 "smtp-client-service.c"
		_state_1:
#line 320 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp14_ = geary_smtp_client_session_login_finish (_data_->_tmp12_, _data_->_res_, &_data_->_inner_error0_);
#line 320 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 320 "../src/engine/smtp/smtp-client-service.vala"
		_geary_smtp_response_unref0 (_data_->_tmp15_);
#line 320 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3225 "smtp-client-service.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 319 "../src/engine/smtp/smtp-client-service.vala"
		_data_->login_err = _data_->_inner_error0_;
#line 319 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_inner_error0_ = NULL;
#line 322 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp16_ = _data_->login_err;
#line 322 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp17_ = _data_->_tmp16_->message;
#line 322 "../src/engine/smtp/smtp-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "SMTP login error: %s", _data_->_tmp17_);
#line 323 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp18_ = _data_->login_err;
#line 323 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp19_ = _g_error_copy0 (_data_->_tmp18_);
#line 323 "../src/engine/smtp/smtp-client-service.vala"
		_g_error_free0 (_data_->smtp_err);
#line 323 "../src/engine/smtp/smtp-client-service.vala"
		_data_->smtp_err = _data_->_tmp19_;
#line 319 "../src/engine/smtp/smtp-client-service.vala"
		_g_error_free0 (_data_->login_err);
#line 3252 "smtp-client-service.c"
	}
	__finally0:
#line 319 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 319 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 319 "../src/engine/smtp/smtp-client-service.vala"
		_g_error_free0 (_data_->smtp_err);
#line 319 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->smtp);
#line 319 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->login);
#line 319 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 319 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3269 "smtp-client-service.c"
	}
#line 326 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp20_ = _data_->smtp_err;
#line 326 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp20_ == NULL) {
#line 331 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp21_ = geary_email_header_set_get_sender (G_TYPE_CHECK_INSTANCE_CAST (_data_->rfc822, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 331 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 331 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp23_ = _g_object_ref0 (_data_->_tmp22_);
#line 331 "../src/engine/smtp/smtp-client-service.vala"
		_data_->reverse_path = _data_->_tmp23_;
#line 332 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp24_ = _data_->reverse_path;
#line 332 "../src/engine/smtp/smtp-client-service.vala"
		if (_data_->_tmp24_ == NULL) {
#line 335 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp25_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_data_->rfc822, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 335 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp26_ = _data_->_tmp25_;
#line 335 "../src/engine/smtp/smtp-client-service.vala"
			if (_data_->_tmp26_ != NULL) {
#line 3293 "smtp-client-service.c"
				{
#line 336 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp27_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (_data_->rfc822, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 336 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp28_ = _data_->_tmp27_;
#line 336 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_from_list = _data_->_tmp28_;
#line 336 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp29_ = _data_->_from_list;
#line 336 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp30_ = geary_rf_c822_mailbox_addresses_get_size (_data_->_tmp29_);
#line 336 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp31_ = _data_->_tmp30_;
#line 336 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_from_size = _data_->_tmp31_;
#line 336 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_from_index = -1;
#line 336 "../src/engine/smtp/smtp-client-service.vala"
					while (TRUE) {
#line 336 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_from_index = _data_->_from_index + 1;
#line 336 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp32_ = _data_->_from_index;
#line 336 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp33_ = _data_->_from_size;
#line 336 "../src/engine/smtp/smtp-client-service.vala"
						if (!(_data_->_tmp32_ < _data_->_tmp33_)) {
#line 336 "../src/engine/smtp/smtp-client-service.vala"
							break;
#line 3323 "smtp-client-service.c"
						}
#line 336 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp34_ = _data_->_from_list;
#line 336 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp35_ = geary_rf_c822_mailbox_addresses_get (_data_->_tmp34_, _data_->_from_index);
#line 336 "../src/engine/smtp/smtp-client-service.vala"
						_data_->from = _data_->_tmp35_;
#line 337 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp36_ = geary_client_service_get_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 337 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp37_ = _data_->_tmp36_;
#line 337 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp38_ = _data_->from;
#line 337 "../src/engine/smtp/smtp-client-service.vala"
						if (geary_account_information_has_sender_mailbox (_data_->_tmp37_, _data_->_tmp38_)) {
#line 338 "../src/engine/smtp/smtp-client-service.vala"
							_data_->_tmp39_ = _data_->from;
#line 338 "../src/engine/smtp/smtp-client-service.vala"
							_data_->_tmp40_ = _g_object_ref0 (_data_->_tmp39_);
#line 338 "../src/engine/smtp/smtp-client-service.vala"
							_g_object_unref0 (_data_->reverse_path);
#line 338 "../src/engine/smtp/smtp-client-service.vala"
							_data_->reverse_path = _data_->_tmp40_;
#line 339 "../src/engine/smtp/smtp-client-service.vala"
							_g_object_unref0 (_data_->from);
#line 339 "../src/engine/smtp/smtp-client-service.vala"
							break;
#line 3351 "smtp-client-service.c"
						}
#line 336 "../src/engine/smtp/smtp-client-service.vala"
						_g_object_unref0 (_data_->from);
#line 3355 "smtp-client-service.c"
					}
				}
			}
#line 344 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp41_ = _data_->reverse_path;
#line 344 "../src/engine/smtp/smtp-client-service.vala"
			if (_data_->_tmp41_ == NULL) {
#line 348 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp42_ = geary_client_service_get_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService));
#line 348 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp43_ = _data_->_tmp42_;
#line 348 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp44_ = geary_account_information_get_primary_mailbox (_data_->_tmp43_);
#line 348 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp45_ = _data_->_tmp44_;
#line 348 "../src/engine/smtp/smtp-client-service.vala"
				_g_object_unref0 (_data_->reverse_path);
#line 348 "../src/engine/smtp/smtp-client-service.vala"
				_data_->reverse_path = _data_->_tmp45_;
#line 3375 "smtp-client-service.c"
			}
		}
		{
#line 354 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp46_ = _data_->smtp;
#line 354 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp47_ = _data_->reverse_path;
#line 354 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_state_ = 2;
#line 354 "../src/engine/smtp/smtp-client-service.vala"
			geary_smtp_client_session_send_email_async (_data_->_tmp46_, _data_->_tmp47_, _data_->rfc822, _data_->cancellable, geary_smtp_client_service_send_email_internal_ready, _data_);
#line 354 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 3389 "smtp-client-service.c"
			_state_2:
#line 354 "../src/engine/smtp/smtp-client-service.vala"
			geary_smtp_client_session_send_email_finish (_data_->_tmp46_, _data_->_res_, &_data_->_inner_error0_);
#line 354 "../src/engine/smtp/smtp-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3395 "smtp-client-service.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 353 "../src/engine/smtp/smtp-client-service.vala"
			_data_->send_err = _data_->_inner_error0_;
#line 353 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_inner_error0_ = NULL;
#line 356 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp48_ = _data_->send_err;
#line 356 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp49_ = _data_->_tmp48_->message;
#line 356 "../src/engine/smtp/smtp-client-service.vala"
			geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "SMTP send mail error: %s", _data_->_tmp49_);
#line 357 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp50_ = _data_->send_err;
#line 357 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp51_ = _g_error_copy0 (_data_->_tmp50_);
#line 357 "../src/engine/smtp/smtp-client-service.vala"
			_g_error_free0 (_data_->smtp_err);
#line 357 "../src/engine/smtp/smtp-client-service.vala"
			_data_->smtp_err = _data_->_tmp51_;
#line 353 "../src/engine/smtp/smtp-client-service.vala"
			_g_error_free0 (_data_->send_err);
#line 3422 "smtp-client-service.c"
		}
		__finally1:
#line 353 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 353 "../src/engine/smtp/smtp-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 353 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->reverse_path);
#line 353 "../src/engine/smtp/smtp-client-service.vala"
			_g_error_free0 (_data_->smtp_err);
#line 353 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->smtp);
#line 353 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->login);
#line 353 "../src/engine/smtp/smtp-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 353 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 3441 "smtp-client-service.c"
		}
#line 326 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->reverse_path);
#line 3445 "smtp-client-service.c"
	}
	{
#line 363 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp52_ = _data_->smtp;
#line 363 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_state_ = 3;
#line 363 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_session_logout_async (_data_->_tmp52_, FALSE, NULL, geary_smtp_client_service_send_email_internal_ready, _data_);
#line 363 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3456 "smtp-client-service.c"
		_state_3:
#line 363 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp53_ = geary_smtp_client_session_logout_finish (_data_->_tmp52_, _data_->_res_, &_data_->_inner_error0_);
#line 363 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp54_ = _data_->_tmp53_;
#line 363 "../src/engine/smtp/smtp-client-service.vala"
		_geary_smtp_response_unref0 (_data_->_tmp54_);
#line 363 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3466 "smtp-client-service.c"
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
#line 361 "../src/engine/smtp/smtp-client-service.vala"
		_data_->err = _data_->_inner_error0_;
#line 361 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_inner_error0_ = NULL;
#line 365 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp55_ = _data_->smtp;
#line 365 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp56_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp55_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 365 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp57_ = _data_->_tmp56_;
#line 365 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp58_ = _data_->err;
#line 365 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp59_ = _data_->_tmp58_->message;
#line 365 "../src/engine/smtp/smtp-client-service.vala"
		geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Unable to disconnect from SMTP server %s: %s", _data_->_tmp57_, _data_->_tmp59_);
#line 365 "../src/engine/smtp/smtp-client-service.vala"
		_g_free0 (_data_->_tmp57_);
#line 361 "../src/engine/smtp/smtp-client-service.vala"
		_g_error_free0 (_data_->err);
#line 3493 "smtp-client-service.c"
	}
	__finally2:
#line 361 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 361 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 361 "../src/engine/smtp/smtp-client-service.vala"
		_g_error_free0 (_data_->smtp_err);
#line 361 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->smtp);
#line 361 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->login);
#line 361 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 361 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3510 "smtp-client-service.c"
	}
#line 368 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp60_ = _data_->self->priv->_sending_monitor;
#line 368 "../src/engine/smtp/smtp-client-service.vala"
	geary_progress_monitor_notify_finish (_data_->_tmp60_);
#line 370 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp61_ = _data_->smtp_err;
#line 370 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp61_ != NULL) {
#line 371 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp62_ = _data_->smtp_err;
#line 371 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp63_ = _g_error_copy0 (_data_->_tmp62_);
#line 371 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_inner_error0_ = _data_->_tmp63_;
#line 371 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 371 "../src/engine/smtp/smtp-client-service.vala"
		_g_error_free0 (_data_->smtp_err);
#line 371 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->smtp);
#line 371 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->login);
#line 371 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 371 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3538 "smtp-client-service.c"
	}
#line 307 "../src/engine/smtp/smtp-client-service.vala"
	_g_error_free0 (_data_->smtp_err);
#line 307 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->smtp);
#line 307 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->login);
#line 307 "../src/engine/smtp/smtp-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 307 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_state_ != 0) {
#line 307 "../src/engine/smtp/smtp-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 307 "../src/engine/smtp/smtp-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3554 "smtp-client-service.c"
		}
	}
#line 307 "../src/engine/smtp/smtp-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 307 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 3561 "smtp-client-service.c"
}

static void
geary_smtp_client_service_save_sent_mail_data_free (gpointer _data)
{
	GearySmtpClientServiceSaveSentMailData* _data_;
	_data_ = _data;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->message);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_slice_free (GearySmtpClientServiceSaveSentMailData, _data_);
#line 3577 "smtp-client-service.c"
}

static void
geary_smtp_client_service_save_sent_mail (GearySmtpClientService* self,
                                          GearyEmail* message,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	GearySmtpClientServiceSaveSentMailData* _data_;
	GearySmtpClientService* _tmp0_;
	GearyEmail* _tmp1_;
	GCancellable* _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_IS_EMAIL (message));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_slice_new0 (GearySmtpClientServiceSaveSentMailData);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_service_save_sent_mail_data_free);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self = _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = _g_object_ref0 (message);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->message);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->message = _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->cancellable = _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_save_sent_mail_co (_data_);
#line 3621 "smtp-client-service.c"
}

static void
geary_smtp_client_service_save_sent_mail_finish (GearySmtpClientService* self,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	GearySmtpClientServiceSaveSentMailData* _data_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	if (NULL == _data_) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		return;
#line 3636 "smtp-client-service.c"
	}
}

static void
geary_smtp_client_service_save_sent_mail_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	GearySmtpClientServiceSaveSentMailData* _data_;
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = _user_data_;
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_source_object_ = source_object;
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_res_ = _res_;
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_save_sent_mail_co (_data_);
#line 3654 "smtp-client-service.c"
}

static gboolean
geary_smtp_client_service_save_sent_mail_co (GearySmtpClientServiceSaveSentMailData* _data_)
{
#line 374 "../src/engine/smtp/smtp-client-service.vala"
	switch (_data_->_state_) {
#line 374 "../src/engine/smtp/smtp-client-service.vala"
		case 0:
#line 3664 "smtp-client-service.c"
		goto _state_0;
#line 374 "../src/engine/smtp/smtp-client-service.vala"
		case 1:
#line 3668 "smtp-client-service.c"
		goto _state_1;
#line 374 "../src/engine/smtp/smtp-client-service.vala"
		case 2:
#line 3672 "smtp-client-service.c"
		goto _state_2;
#line 374 "../src/engine/smtp/smtp-client-service.vala"
		case 3:
#line 3676 "smtp-client-service.c"
		goto _state_3;
#line 374 "../src/engine/smtp/smtp-client-service.vala"
		case 4:
#line 3680 "smtp-client-service.c"
		goto _state_4;
#line 374 "../src/engine/smtp/smtp-client-service.vala"
		case 5:
#line 3684 "smtp-client-service.c"
		goto _state_5;
		default:
#line 374 "../src/engine/smtp/smtp-client-service.vala"
		g_assert_not_reached ();
#line 3689 "smtp-client-service.c"
	}
	_state_0:
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp1_ = geary_smtp_client_service_get_owner (_data_->self);
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_state_ = 1;
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	geary_account_get_required_special_folder_async (_data_->_tmp2_, GEARY_FOLDER_SPECIAL_USE_SENT, _data_->cancellable, geary_smtp_client_service_save_sent_mail_ready, _data_);
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 3702 "smtp-client-service.c"
	_state_1:
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp3_ = geary_account_get_required_special_folder_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp0_ = _data_->_tmp3_;
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 377 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 377 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 377 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3716 "smtp-client-service.c"
	}
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp4_ = _g_object_ref0 (GEARY_FOLDER_SUPPORT_IS_CREATE (_data_->_tmp0_) ? ((GearyFolderSupportCreate*) _data_->_tmp0_) : NULL);
#line 377 "../src/engine/smtp/smtp-client-service.vala"
	_data_->create = _data_->_tmp4_;
#line 382 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp5_ = _data_->create;
#line 382 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp5_ == NULL) {
#line 383 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp6_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_UNSUPPORTED, "Save sent mail enabled, but no writable sent mail folder");
#line 383 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_inner_error0_ = _data_->_tmp6_;
#line 383 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 383 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->create);
#line 383 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 383 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 383 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3740 "smtp-client-service.c"
	}
#line 388 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp7_ = geary_email_get_message (_data_->message, &_data_->_inner_error0_);
#line 388 "../src/engine/smtp/smtp-client-service.vala"
	_data_->raw = _data_->_tmp7_;
#line 388 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 388 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 388 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->create);
#line 388 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 388 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 388 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3758 "smtp-client-service.c"
	}
#line 389 "../src/engine/smtp/smtp-client-service.vala"
	_data_->open = FALSE;
#line 3762 "smtp-client-service.c"
	{
#line 391 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp8_ = _data_->create;
#line 391 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_state_ = 2;
#line 391 "../src/engine/smtp/smtp-client-service.vala"
		geary_folder_open_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEARY_TYPE_FOLDER, GearyFolder), GEARY_FOLDER_OPEN_FLAGS_NO_DELAY, _data_->cancellable, geary_smtp_client_service_save_sent_mail_ready, _data_);
#line 391 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3772 "smtp-client-service.c"
		_state_2:
#line 391 "../src/engine/smtp/smtp-client-service.vala"
		geary_folder_open_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error0_);
#line 391 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3778 "smtp-client-service.c"
			goto __finally0;
		}
#line 392 "../src/engine/smtp/smtp-client-service.vala"
		_data_->open = TRUE;
#line 393 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp9_ = _data_->create;
#line 393 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp10_ = _data_->raw;
#line 393 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_state_ = 3;
#line 393 "../src/engine/smtp/smtp-client-service.vala"
		geary_folder_support_create_create_email_async (_data_->_tmp9_, _data_->_tmp10_, NULL, NULL, _data_->cancellable, geary_smtp_client_service_save_sent_mail_ready, _data_);
#line 393 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3793 "smtp-client-service.c"
		_state_3:
#line 393 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp11_ = geary_folder_support_create_create_email_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error0_);
#line 393 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 393 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->_tmp12_);
#line 393 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3803 "smtp-client-service.c"
			goto __finally0;
		}
#line 394 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_tmp13_ = _data_->create;
#line 394 "../src/engine/smtp/smtp-client-service.vala"
		_data_->_state_ = 4;
#line 394 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_service_wait_for_message (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, GEARY_TYPE_FOLDER, GearyFolder), _data_->message, _data_->cancellable, geary_smtp_client_service_save_sent_mail_ready, _data_);
#line 394 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3814 "smtp-client-service.c"
		_state_4:
#line 394 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_service_wait_for_message_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 394 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3820 "smtp-client-service.c"
			goto __finally0;
		}
	}
	__finally0:
	{
#line 396 "../src/engine/smtp/smtp-client-service.vala"
		if (_data_->open) {
#line 3828 "smtp-client-service.c"
			{
#line 398 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp14_ = _data_->create;
#line 398 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_state_ = 5;
#line 398 "../src/engine/smtp/smtp-client-service.vala"
				geary_folder_close_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, GEARY_TYPE_FOLDER, GearyFolder), NULL, geary_smtp_client_service_save_sent_mail_ready, _data_);
#line 398 "../src/engine/smtp/smtp-client-service.vala"
				return FALSE;
#line 3838 "smtp-client-service.c"
				_state_5:
#line 398 "../src/engine/smtp/smtp-client-service.vala"
				geary_folder_close_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error1_);
#line 398 "../src/engine/smtp/smtp-client-service.vala"
				if (G_UNLIKELY (_data_->_inner_error1_ != NULL)) {
#line 3844 "smtp-client-service.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
#line 397 "../src/engine/smtp/smtp-client-service.vala"
				_data_->e = _data_->_inner_error1_;
#line 397 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_inner_error1_ = NULL;
#line 400 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp15_ = _data_->create;
#line 400 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp16_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 400 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp17_ = _data_->_tmp16_;
#line 400 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp18_ = _data_->e;
#line 400 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp19_ = _data_->_tmp18_->message;
#line 400 "../src/engine/smtp/smtp-client-service.vala"
				geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error closing folder %s: %s", _data_->_tmp17_, _data_->_tmp19_);
#line 400 "../src/engine/smtp/smtp-client-service.vala"
				_g_free0 (_data_->_tmp17_);
#line 397 "../src/engine/smtp/smtp-client-service.vala"
				_g_error_free0 (_data_->e);
#line 3871 "smtp-client-service.c"
			}
			__finally1:
#line 397 "../src/engine/smtp/smtp-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error1_ != NULL)) {
#line 397 "../src/engine/smtp/smtp-client-service.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error1_);
#line 397 "../src/engine/smtp/smtp-client-service.vala"
				_g_object_unref0 (_data_->raw);
#line 397 "../src/engine/smtp/smtp-client-service.vala"
				_g_object_unref0 (_data_->create);
#line 397 "../src/engine/smtp/smtp-client-service.vala"
				_g_object_unref0 (_data_->_tmp0_);
#line 397 "../src/engine/smtp/smtp-client-service.vala"
				g_object_unref (_data_->_async_result);
#line 397 "../src/engine/smtp/smtp-client-service.vala"
				return FALSE;
#line 3888 "smtp-client-service.c"
			}
		}
	}
#line 390 "../src/engine/smtp/smtp-client-service.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 390 "../src/engine/smtp/smtp-client-service.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 390 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->raw);
#line 390 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->create);
#line 390 "../src/engine/smtp/smtp-client-service.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 390 "../src/engine/smtp/smtp-client-service.vala"
		g_object_unref (_data_->_async_result);
#line 390 "../src/engine/smtp/smtp-client-service.vala"
		return FALSE;
#line 3906 "smtp-client-service.c"
	}
#line 374 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->raw);
#line 374 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->create);
#line 374 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 374 "../src/engine/smtp/smtp-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 374 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_state_ != 0) {
#line 374 "../src/engine/smtp/smtp-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 374 "../src/engine/smtp/smtp-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3922 "smtp-client-service.c"
		}
	}
#line 374 "../src/engine/smtp/smtp-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 374 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 3929 "smtp-client-service.c"
}

static void
geary_smtp_client_service_sync_sent_mail_data_free (gpointer _data)
{
	GearySmtpClientServiceSyncSentMailData* _data_;
	_data_ = _data;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->message);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_slice_free (GearySmtpClientServiceSyncSentMailData, _data_);
#line 3945 "smtp-client-service.c"
}

static void
geary_smtp_client_service_sync_sent_mail (GearySmtpClientService* self,
                                          GearyEmail* message,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	GearySmtpClientServiceSyncSentMailData* _data_;
	GearySmtpClientService* _tmp0_;
	GearyEmail* _tmp1_;
	GCancellable* _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_IS_EMAIL (message));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_slice_new0 (GearySmtpClientServiceSyncSentMailData);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_service_sync_sent_mail_data_free);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self = _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = _g_object_ref0 (message);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->message);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->message = _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->cancellable = _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_sync_sent_mail_co (_data_);
#line 3989 "smtp-client-service.c"
}

static void
geary_smtp_client_service_sync_sent_mail_finish (GearySmtpClientService* self,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	GearySmtpClientServiceSyncSentMailData* _data_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	if (NULL == _data_) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		return;
#line 4004 "smtp-client-service.c"
	}
}

static void
geary_smtp_client_service_sync_sent_mail_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	GearySmtpClientServiceSyncSentMailData* _data_;
#line 413 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = _user_data_;
#line 413 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_source_object_ = source_object;
#line 413 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_res_ = _res_;
#line 413 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_sync_sent_mail_co (_data_);
#line 4022 "smtp-client-service.c"
}

static gboolean
geary_smtp_client_service_sync_sent_mail_co (GearySmtpClientServiceSyncSentMailData* _data_)
{
#line 406 "../src/engine/smtp/smtp-client-service.vala"
	switch (_data_->_state_) {
#line 406 "../src/engine/smtp/smtp-client-service.vala"
		case 0:
#line 4032 "smtp-client-service.c"
		goto _state_0;
#line 406 "../src/engine/smtp/smtp-client-service.vala"
		case 1:
#line 4036 "smtp-client-service.c"
		goto _state_1;
#line 406 "../src/engine/smtp/smtp-client-service.vala"
		case 2:
#line 4040 "smtp-client-service.c"
		goto _state_2;
#line 406 "../src/engine/smtp/smtp-client-service.vala"
		case 3:
#line 4044 "smtp-client-service.c"
		goto _state_3;
#line 406 "../src/engine/smtp/smtp-client-service.vala"
		case 4:
#line 4048 "smtp-client-service.c"
		goto _state_4;
		default:
#line 406 "../src/engine/smtp/smtp-client-service.vala"
		g_assert_not_reached ();
#line 4053 "smtp-client-service.c"
	}
	_state_0:
#line 409 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp0_ = geary_smtp_client_service_get_owner (_data_->self);
#line 409 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 409 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp2_ = geary_account_get_special_folder (_data_->_tmp1_, GEARY_FOLDER_SPECIAL_USE_SENT);
#line 409 "../src/engine/smtp/smtp-client-service.vala"
	_data_->sent = _data_->_tmp2_;
#line 410 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp3_ = _data_->sent;
#line 410 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp3_ != NULL) {
#line 411 "../src/engine/smtp/smtp-client-service.vala"
		_data_->open = FALSE;
#line 4070 "smtp-client-service.c"
		{
#line 413 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp4_ = _data_->sent;
#line 413 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_state_ = 1;
#line 413 "../src/engine/smtp/smtp-client-service.vala"
			geary_folder_open_async (_data_->_tmp4_, GEARY_FOLDER_OPEN_FLAGS_NO_DELAY, _data_->cancellable, geary_smtp_client_service_sync_sent_mail_ready, _data_);
#line 413 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 4080 "smtp-client-service.c"
			_state_1:
#line 413 "../src/engine/smtp/smtp-client-service.vala"
			geary_folder_open_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error0_);
#line 413 "../src/engine/smtp/smtp-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4086 "smtp-client-service.c"
				goto __finally0;
			}
#line 414 "../src/engine/smtp/smtp-client-service.vala"
			_data_->open = TRUE;
#line 415 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp5_ = _data_->sent;
#line 415 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_state_ = 2;
#line 415 "../src/engine/smtp/smtp-client-service.vala"
			geary_folder_synchronise_remote (_data_->_tmp5_, _data_->cancellable, geary_smtp_client_service_sync_sent_mail_ready, _data_);
#line 415 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 4099 "smtp-client-service.c"
			_state_2:
#line 415 "../src/engine/smtp/smtp-client-service.vala"
			geary_folder_synchronise_remote_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error0_);
#line 415 "../src/engine/smtp/smtp-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4105 "smtp-client-service.c"
				goto __finally0;
			}
#line 416 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_tmp6_ = _data_->sent;
#line 416 "../src/engine/smtp/smtp-client-service.vala"
			_data_->_state_ = 3;
#line 416 "../src/engine/smtp/smtp-client-service.vala"
			geary_smtp_client_service_wait_for_message (_data_->self, _data_->_tmp6_, _data_->message, _data_->cancellable, geary_smtp_client_service_sync_sent_mail_ready, _data_);
#line 416 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 4116 "smtp-client-service.c"
			_state_3:
#line 416 "../src/engine/smtp/smtp-client-service.vala"
			geary_smtp_client_service_wait_for_message_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 416 "../src/engine/smtp/smtp-client-service.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4122 "smtp-client-service.c"
				goto __finally0;
			}
		}
		__finally0:
		{
#line 418 "../src/engine/smtp/smtp-client-service.vala"
			if (_data_->open) {
#line 4130 "smtp-client-service.c"
				{
#line 420 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp7_ = _data_->sent;
#line 420 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_state_ = 4;
#line 420 "../src/engine/smtp/smtp-client-service.vala"
					geary_folder_close_async (_data_->_tmp7_, NULL, geary_smtp_client_service_sync_sent_mail_ready, _data_);
#line 420 "../src/engine/smtp/smtp-client-service.vala"
					return FALSE;
#line 4140 "smtp-client-service.c"
					_state_4:
#line 420 "../src/engine/smtp/smtp-client-service.vala"
					geary_folder_close_finish (_data_->_tmp7_, _data_->_res_, &_data_->_inner_error1_);
#line 420 "../src/engine/smtp/smtp-client-service.vala"
					if (G_UNLIKELY (_data_->_inner_error1_ != NULL)) {
#line 4146 "smtp-client-service.c"
						goto __catch1_g_error;
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
#line 419 "../src/engine/smtp/smtp-client-service.vala"
					_data_->e = _data_->_inner_error1_;
#line 419 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_inner_error1_ = NULL;
#line 422 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp8_ = _data_->sent;
#line 422 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp9_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 422 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp10_ = _data_->_tmp9_;
#line 422 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp11_ = _data_->e;
#line 422 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp12_ = _data_->_tmp11_->message;
#line 422 "../src/engine/smtp/smtp-client-service.vala"
					geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Error closing folder %s: %s", _data_->_tmp10_, _data_->_tmp12_);
#line 422 "../src/engine/smtp/smtp-client-service.vala"
					_g_free0 (_data_->_tmp10_);
#line 419 "../src/engine/smtp/smtp-client-service.vala"
					_g_error_free0 (_data_->e);
#line 4173 "smtp-client-service.c"
				}
				__finally1:
#line 419 "../src/engine/smtp/smtp-client-service.vala"
				if (G_UNLIKELY (_data_->_inner_error1_ != NULL)) {
#line 419 "../src/engine/smtp/smtp-client-service.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error1_);
#line 419 "../src/engine/smtp/smtp-client-service.vala"
					_g_object_unref0 (_data_->sent);
#line 419 "../src/engine/smtp/smtp-client-service.vala"
					g_object_unref (_data_->_async_result);
#line 419 "../src/engine/smtp/smtp-client-service.vala"
					return FALSE;
#line 4186 "smtp-client-service.c"
				}
			}
		}
#line 412 "../src/engine/smtp/smtp-client-service.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 412 "../src/engine/smtp/smtp-client-service.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 412 "../src/engine/smtp/smtp-client-service.vala"
			_g_object_unref0 (_data_->sent);
#line 412 "../src/engine/smtp/smtp-client-service.vala"
			g_object_unref (_data_->_async_result);
#line 412 "../src/engine/smtp/smtp-client-service.vala"
			return FALSE;
#line 4200 "smtp-client-service.c"
		}
	}
#line 406 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->sent);
#line 406 "../src/engine/smtp/smtp-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 406 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_state_ != 0) {
#line 406 "../src/engine/smtp/smtp-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 406 "../src/engine/smtp/smtp-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4213 "smtp-client-service.c"
		}
	}
#line 406 "../src/engine/smtp/smtp-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 406 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 4220 "smtp-client-service.c"
}

static void
geary_smtp_client_service_wait_for_message_data_free (gpointer _data)
{
	GearySmtpClientServiceWaitForMessageData* _data_;
	_data_ = _data;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->location);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->sent);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_slice_free (GearySmtpClientServiceWaitForMessageData, _data_);
#line 4238 "smtp-client-service.c"
}

static void
geary_smtp_client_service_wait_for_message (GearySmtpClientService* self,
                                            GearyFolder* location,
                                            GearyEmail* sent,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	GearySmtpClientServiceWaitForMessageData* _data_;
	GearySmtpClientService* _tmp0_;
	GearyFolder* _tmp1_;
	GearyEmail* _tmp2_;
	GCancellable* _tmp3_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_SMTP_IS_CLIENT_SERVICE (self));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_IS_FOLDER (location));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (GEARY_IS_EMAIL (sent));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_slice_new0 (GearySmtpClientServiceWaitForMessageData);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, geary_smtp_client_service_wait_for_message_data_free);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->self = _tmp0_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = _g_object_ref0 (location);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->location);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->location = _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp2_ = _g_object_ref0 (sent);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->sent);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->sent = _tmp2_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_->cancellable = _tmp3_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_wait_for_message_co (_data_);
#line 4292 "smtp-client-service.c"
}

static void
geary_smtp_client_service_wait_for_message_finish (GearySmtpClientService* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	GearySmtpClientServiceWaitForMessageData* _data_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	if (NULL == _data_) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		return;
#line 4307 "smtp-client-service.c"
	}
}

static void
geary_smtp_client_service_wait_for_message_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	GearySmtpClientServiceWaitForMessageData* _data_;
#line 441 "../src/engine/smtp/smtp-client-service.vala"
	_data_ = _user_data_;
#line 441 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_source_object_ = source_object;
#line 441 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_res_ = _res_;
#line 441 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_wait_for_message_co (_data_);
#line 4325 "smtp-client-service.c"
}

static gboolean
_geary_smtp_client_service_wait_for_message_co_gsource_func (gpointer self)
{
	gboolean result;
	result = geary_smtp_client_service_wait_for_message_co (self);
#line 455 "../src/engine/smtp/smtp-client-service.vala"
	return result;
#line 4335 "smtp-client-service.c"
}

static gboolean
geary_smtp_client_service_wait_for_message_co (GearySmtpClientServiceWaitForMessageData* _data_)
{
#line 433 "../src/engine/smtp/smtp-client-service.vala"
	switch (_data_->_state_) {
#line 433 "../src/engine/smtp/smtp-client-service.vala"
		case 0:
#line 4345 "smtp-client-service.c"
		goto _state_0;
#line 433 "../src/engine/smtp/smtp-client-service.vala"
		case 1:
#line 4349 "smtp-client-service.c"
		goto _state_1;
#line 433 "../src/engine/smtp/smtp-client-service.vala"
		case 2:
#line 4353 "smtp-client-service.c"
		goto _state_2;
		default:
#line 433 "../src/engine/smtp/smtp-client-service.vala"
		g_assert_not_reached ();
#line 4358 "smtp-client-service.c"
	}
	_state_0:
#line 437 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp0_ = geary_email_header_set_get_message_id (G_TYPE_CHECK_INSTANCE_CAST (_data_->sent, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 437 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 437 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->_tmp1_);
#line 437 "../src/engine/smtp/smtp-client-service.vala"
	_data_->id = _data_->_tmp2_;
#line 438 "../src/engine/smtp/smtp-client-service.vala"
	_data_->_tmp3_ = _data_->id;
#line 438 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_tmp3_ != NULL) {
#line 439 "../src/engine/smtp/smtp-client-service.vala"
		static const gint MAX_RETRIES = 3;
#line 4375 "smtp-client-service.c"
		{
#line 440 "../src/engine/smtp/smtp-client-service.vala"
			_data_->i = 0;
#line 4379 "smtp-client-service.c"
			{
#line 440 "../src/engine/smtp/smtp-client-service.vala"
				_data_->_tmp4_ = TRUE;
#line 440 "../src/engine/smtp/smtp-client-service.vala"
				while (TRUE) {
#line 440 "../src/engine/smtp/smtp-client-service.vala"
					if (!_data_->_tmp4_) {
#line 440 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp5_ = _data_->i;
#line 440 "../src/engine/smtp/smtp-client-service.vala"
						_data_->i = _data_->_tmp5_ + 1;
#line 4391 "smtp-client-service.c"
					}
#line 440 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp4_ = FALSE;
#line 440 "../src/engine/smtp/smtp-client-service.vala"
					if (!(_data_->i < MAX_RETRIES)) {
#line 440 "../src/engine/smtp/smtp-client-service.vala"
						break;
#line 4399 "smtp-client-service.c"
					}
#line 441 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_state_ = 1;
#line 441 "../src/engine/smtp/smtp-client-service.vala"
					geary_folder_list_email_by_id_async (_data_->location, NULL, 1, GEARY_EMAIL_FIELD_REFERENCES, GEARY_FOLDER_LIST_FLAGS_NONE, _data_->cancellable, geary_smtp_client_service_wait_for_message_ready, _data_);
#line 441 "../src/engine/smtp/smtp-client-service.vala"
					return FALSE;
#line 4407 "smtp-client-service.c"
					_state_1:
#line 441 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp6_ = geary_folder_list_email_by_id_finish (_data_->location, _data_->_res_, &_data_->_inner_error0_);
#line 441 "../src/engine/smtp/smtp-client-service.vala"
					_data_->list = _data_->_tmp6_;
#line 441 "../src/engine/smtp/smtp-client-service.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 441 "../src/engine/smtp/smtp-client-service.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 441 "../src/engine/smtp/smtp-client-service.vala"
						_g_object_unref0 (_data_->id);
#line 441 "../src/engine/smtp/smtp-client-service.vala"
						g_object_unref (_data_->_async_result);
#line 441 "../src/engine/smtp/smtp-client-service.vala"
						return FALSE;
#line 4423 "smtp-client-service.c"
					}
#line 444 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_tmp8_ = _data_->list;
#line 444 "../src/engine/smtp/smtp-client-service.vala"
					if (_data_->_tmp8_ != NULL) {
#line 444 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp9_ = _data_->list;
#line 444 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp10_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, GEE_TYPE_COLLECTION, GeeCollection));
#line 444 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp11_ = _data_->_tmp10_;
#line 444 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp7_ = !_data_->_tmp11_;
#line 4437 "smtp-client-service.c"
					} else {
#line 444 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp7_ = FALSE;
#line 4441 "smtp-client-service.c"
					}
#line 444 "../src/engine/smtp/smtp-client-service.vala"
					if (_data_->_tmp7_) {
#line 445 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp12_ = _data_->list;
#line 445 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp13_ = geary_collection_first (GEARY_TYPE_EMAIL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, GEE_TYPE_COLLECTION, GeeCollection));
#line 445 "../src/engine/smtp/smtp-client-service.vala"
						_data_->listed = (GearyEmail*) _data_->_tmp13_;
#line 446 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp15_ = _data_->listed;
#line 446 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp16_ = geary_email_header_set_get_message_id (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 446 "../src/engine/smtp/smtp-client-service.vala"
						_data_->_tmp17_ = _data_->_tmp16_;
#line 446 "../src/engine/smtp/smtp-client-service.vala"
						if (_data_->_tmp17_ != NULL) {
#line 447 "../src/engine/smtp/smtp-client-service.vala"
							_data_->_tmp18_ = _data_->listed;
#line 447 "../src/engine/smtp/smtp-client-service.vala"
							_data_->_tmp19_ = geary_email_header_set_get_message_id (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp18_, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 447 "../src/engine/smtp/smtp-client-service.vala"
							_data_->_tmp20_ = _data_->_tmp19_;
#line 447 "../src/engine/smtp/smtp-client-service.vala"
							_data_->_tmp21_ = _data_->id;
#line 447 "../src/engine/smtp/smtp-client-service.vala"
							_data_->_tmp14_ = geary_message_data_string_message_data_equal_to (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp20_, GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA, GearyMessageDataStringMessageData), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp21_, GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA, GearyMessageDataStringMessageData));
#line 4469 "smtp-client-service.c"
						} else {
#line 446 "../src/engine/smtp/smtp-client-service.vala"
							_data_->_tmp14_ = FALSE;
#line 4473 "smtp-client-service.c"
						}
#line 446 "../src/engine/smtp/smtp-client-service.vala"
						if (_data_->_tmp14_) {
#line 448 "../src/engine/smtp/smtp-client-service.vala"
							_g_object_unref0 (_data_->listed);
#line 448 "../src/engine/smtp/smtp-client-service.vala"
							_g_object_unref0 (_data_->list);
#line 448 "../src/engine/smtp/smtp-client-service.vala"
							break;
#line 4483 "smtp-client-service.c"
						}
#line 444 "../src/engine/smtp/smtp-client-service.vala"
						_g_object_unref0 (_data_->listed);
#line 4487 "smtp-client-service.c"
					}
#line 454 "../src/engine/smtp/smtp-client-service.vala"
					geary_logging_source_debug (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource), "Waiting for sent mail...");
#line 455 "../src/engine/smtp/smtp-client-service.vala"
					g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _geary_smtp_client_service_wait_for_message_co_gsource_func, _data_, NULL);
#line 456 "../src/engine/smtp/smtp-client-service.vala"
					_data_->_state_ = 2;
#line 456 "../src/engine/smtp/smtp-client-service.vala"
					return FALSE;
#line 4497 "smtp-client-service.c"
					_state_2:
					;
#line 440 "../src/engine/smtp/smtp-client-service.vala"
					_g_object_unref0 (_data_->list);
#line 4502 "smtp-client-service.c"
				}
			}
		}
	}
#line 433 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (_data_->id);
#line 433 "../src/engine/smtp/smtp-client-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 433 "../src/engine/smtp/smtp-client-service.vala"
	if (_data_->_state_ != 0) {
#line 433 "../src/engine/smtp/smtp-client-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 433 "../src/engine/smtp/smtp-client-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4517 "smtp-client-service.c"
		}
	}
#line 433 "../src/engine/smtp/smtp-client-service.vala"
	g_object_unref (_data_->_async_result);
#line 433 "../src/engine/smtp/smtp-client-service.vala"
	return FALSE;
#line 4524 "smtp-client-service.c"
}

static void
geary_smtp_client_service_class_init (GearySmtpClientServiceClass * klass,
                                      gpointer klass_data)
{
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_type_class_adjust_private_offset (klass, &GearySmtpClientService_private_offset);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	((GearyClientServiceClass *) klass)->start = (void (*) (GearyClientService*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_client_service_real_start;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	((GearyClientServiceClass *) klass)->start_finish = (void (*) (GearyClientService*, GAsyncResult*, GError**)) geary_smtp_client_service_start_finish;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	((GearyClientServiceClass *) klass)->stop = (void (*) (GearyClientService*, GCancellable*, GAsyncReadyCallback, gpointer)) geary_smtp_client_service_real_stop;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	((GearyClientServiceClass *) klass)->stop_finish = (void (*) (GearyClientService*, GAsyncResult*, GError**)) geary_smtp_client_service_stop_finish;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	((GearyClientServiceClass *) klass)->became_reachable = (void (*) (GearyClientService*)) geary_smtp_client_service_real_became_reachable;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	((GearyClientServiceClass *) klass)->became_unreachable = (void (*) (GearyClientService*)) geary_smtp_client_service_real_became_unreachable;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	GEARY_CLIENT_SERVICE_CLASS (klass)->get_logging_domain = (const gchar* (*) (GearyClientService*)) geary_smtp_client_service_real_get_logging_domain;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_smtp_client_service_get_property;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_smtp_client_service_set_property;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_smtp_client_service_finalize;
#line 4555 "smtp-client-service.c"
	/** Folder used for storing and retrieving queued mail. */
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_CLIENT_SERVICE_OUTBOX_PROPERTY, geary_smtp_client_service_properties[GEARY_SMTP_CLIENT_SERVICE_OUTBOX_PROPERTY] = g_param_spec_object ("outbox", "outbox", "outbox", GEARY_OUTBOX_TYPE_FOLDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4559 "smtp-client-service.c"
	/** Progress monitor indicating when email is being sent. */
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_CLIENT_SERVICE_SENDING_MONITOR_PROPERTY, geary_smtp_client_service_properties[GEARY_SMTP_CLIENT_SERVICE_SENDING_MONITOR_PROPERTY] = g_param_spec_object ("sending-monitor", "sending-monitor", "sending-monitor", GEARY_TYPE_PROGRESS_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4563 "smtp-client-service.c"
	/** {@inheritDoc} */
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_CLIENT_SERVICE_LOGGING_DOMAIN_PROPERTY, geary_smtp_client_service_properties[GEARY_SMTP_CLIENT_SERVICE_LOGGING_DOMAIN_PROPERTY] = g_param_spec_string ("logging-domain", "logging-domain", "logging-domain", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4567 "smtp-client-service.c"
	/** Emitted when the manager has sent an email. */
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_signals[GEARY_SMTP_CLIENT_SERVICE_EMAIL_SENT_SIGNAL] = g_signal_new ("email-sent", GEARY_SMTP_TYPE_CLIENT_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_EMAIL);
#line 4571 "smtp-client-service.c"
	/** Emitted when an error occurred sending an email. */
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	geary_smtp_client_service_signals[GEARY_SMTP_CLIENT_SERVICE_REPORT_PROBLEM_SIGNAL] = g_signal_new ("report-problem", GEARY_SMTP_TYPE_CLIENT_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_PROBLEM_REPORT);
#line 4575 "smtp-client-service.c"
}

static void
geary_smtp_client_service_instance_init (GearySmtpClientService * self,
                                         gpointer klass)
{
	GearySimpleProgressMonitor* _tmp0_;
	GearyNonblockingQueue* _tmp1_;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	self->priv = geary_smtp_client_service_get_instance_private (self);
#line 36 "../src/engine/smtp/smtp-client-service.vala"
	self->priv->_outbox = NULL;
#line 39 "../src/engine/smtp/smtp-client-service.vala"
	_tmp0_ = geary_simple_progress_monitor_new (GEARY_PROGRESS_TYPE_ACTIVITY);
#line 39 "../src/engine/smtp/smtp-client-service.vala"
	self->priv->_sending_monitor = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor);
#line 52 "../src/engine/smtp/smtp-client-service.vala"
	_tmp1_ = geary_nonblocking_queue_new_fifo (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 52 "../src/engine/smtp/smtp-client-service.vala"
	self->priv->outbox_queue = _tmp1_;
#line 54 "../src/engine/smtp/smtp-client-service.vala"
	self->priv->queue_cancellable = NULL;
#line 4598 "smtp-client-service.c"
}

static void
geary_smtp_client_service_finalize (GObject * obj)
{
	GearySmtpClientService * self;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_SMTP_TYPE_CLIENT_SERVICE, GearySmtpClientService);
#line 36 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (self->priv->_outbox);
#line 39 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (self->priv->_sending_monitor);
#line 52 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (self->priv->outbox_queue);
#line 54 "../src/engine/smtp/smtp-client-service.vala"
	_g_object_unref0 (self->priv->queue_cancellable);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	G_OBJECT_CLASS (geary_smtp_client_service_parent_class)->finalize (obj);
#line 4617 "smtp-client-service.c"
}

/**
 * Manages connecting to an SMTP network service.
 *
 * This class maintains a queue of email messages to be delivered, and
 * opens SMTP connections to deliver queued messages as needed.
 */
 G_GNUC_NO_INLINE static GType
geary_smtp_client_service_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GearySmtpClientServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_smtp_client_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySmtpClientService), 0, (GInstanceInitFunc) geary_smtp_client_service_instance_init, NULL };
	GType geary_smtp_client_service_type_id;
	geary_smtp_client_service_type_id = g_type_register_static (GEARY_TYPE_CLIENT_SERVICE, "GearySmtpClientService", &g_define_type_info, 0);
	GearySmtpClientService_private_offset = g_type_add_instance_private (geary_smtp_client_service_type_id, sizeof (GearySmtpClientServicePrivate));
	return geary_smtp_client_service_type_id;
}

GType
geary_smtp_client_service_get_type (void)
{
	static gsize geary_smtp_client_service_type_id__once = 0;
	if (g_once_init_enter (&geary_smtp_client_service_type_id__once)) {
		GType geary_smtp_client_service_type_id;
		geary_smtp_client_service_type_id = geary_smtp_client_service_get_type_once ();
		g_once_init_leave (&geary_smtp_client_service_type_id__once, geary_smtp_client_service_type_id);
	}
	return geary_smtp_client_service_type_id__once;
}

static void
_vala_geary_smtp_client_service_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	GearySmtpClientService * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SMTP_TYPE_CLIENT_SERVICE, GearySmtpClientService);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	switch (property_id) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		case GEARY_SMTP_CLIENT_SERVICE_OUTBOX_PROPERTY:
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		g_value_set_object (value, geary_smtp_client_service_get_outbox (self));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		break;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		case GEARY_SMTP_CLIENT_SERVICE_SENDING_MONITOR_PROPERTY:
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		g_value_set_object (value, geary_smtp_client_service_get_sending_monitor (self));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		break;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		case GEARY_SMTP_CLIENT_SERVICE_LOGGING_DOMAIN_PROPERTY:
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		g_value_set_string (value, geary_client_service_get_logging_domain (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_CLIENT_SERVICE, GearyClientService)));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		break;
#line 4676 "smtp-client-service.c"
		default:
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		break;
#line 4682 "smtp-client-service.c"
	}
}

static void
_vala_geary_smtp_client_service_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	GearySmtpClientService * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_SMTP_TYPE_CLIENT_SERVICE, GearySmtpClientService);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
	switch (property_id) {
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		case GEARY_SMTP_CLIENT_SERVICE_OUTBOX_PROPERTY:
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_service_set_outbox (self, g_value_get_object (value));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		break;
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		case GEARY_SMTP_CLIENT_SERVICE_SENDING_MONITOR_PROPERTY:
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		geary_smtp_client_service_set_sending_monitor (self, g_value_get_object (value));
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		break;
#line 4708 "smtp-client-service.c"
		default:
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/engine/smtp/smtp-client-service.vala"
		break;
#line 4714 "smtp-client-service.c"
	}
}

